﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.28
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
		
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
	Private edtFlugzeug As EditText
	Private edtKennzeichen As EditText
	Private edtBemerkung As EditText
	Private edtFlugzeugNr As EditText
	
	Private mFlugzeug As Sdata1	
	Dim sb As StringBuilder
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	'Activity.LoadLayout("Layout1")
	
	Activity.LoadLayout("LayoutFlugzeugInput")
	Select Main.cADE
		Case 1
			Activity.Title="Flugzeug Hinzufügen"
			Activity.TitleColor=Colors.Blue
			Activity.AddMenuItem3("Add", "evClick", LoadBitmap(File.DirAssets, "Add.png"),True)
			InitAdd
		Case 2
			Activity.Title="Flugzeug Ändern/Löschen"
			Activity.TitleColor=Colors.Blue
			Activity.AddMenuItem3("Delete", "evDelete", LoadBitmap(File.DirAssets, "Delete.png"),True)
			Activity.AddMenuItem3("Edit", "evClick", LoadBitmap(File.DirAssets, "Edit.png"),True)
			InitEditDelete
	End Select
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub InitAdd
	edtFlugzeug.Text="Flgz"
	edtKennzeichen.Text="D-1234"
	edtBemerkung.Text="nz"
	edtFlugzeugNr.Text="0"	
End Sub

Sub InitEditDelete
	mFlugzeug.MyId=Main.cFlugzeug.MyId
	
	edtKennzeichen.Text=Main.cFlugzeug.MyKennzeichen
	mFlugzeug.MyKennzeichen=Main.cFlugzeug.MyKennzeichen
	
	edtFlugzeug.Text=Main.cFlugzeug.MyFlugzeug
	mFlugzeug.MyFlugzeug=Main.cFlugzeug.MyFlugzeug
	
	edtFlugzeugNr.Text=Main.cFlugzeug.MyNr
	mFlugzeug.MyNr=Main.cFlugzeug.MyNr
	
	edtBemerkung.Text=Main.cFlugzeug.MyBemerkung
	mFlugzeug.MyBemerkung=Main.cFlugzeug.MyBemerkung
	
	mFlugzeug.MyColor=Main.cFlugzeug.MyColor
	
End Sub

Sub evClick_click	
	Dim ListOfMaps As List	
	ListOfMaps.Initialize
	Dim m As Map
	m.Initialize
	m.Put("Nr", edtFlugzeugNr.Text)
	m.Put("Flugzeug", edtFlugzeug.Text)
	m.Put("Kennzeichen", edtKennzeichen.Text)
	m.Put("Bemerkung", edtBemerkung.Text)
	
	Dim myBool As Boolean
	myBool=Validate
	Select Main.cADE
		Case 1	'Neues Flugzeug
			m.Put("Id", Null)
			ListOfMaps.Add(m)
			If myBool = False Then
				MsgboxAsync(sb,"Warnung!")
			Else
				DBUtils.InsertMaps(Main.SQL1, "Flugzeuge", ListOfMaps)
				Activity.Finish
			End If
		Case 2	'Edit Flugzeug
			m.Put("Id", mFlugzeug.MyId)
			If myBool = False Then
				MsgboxAsync(sb,"Warnung!")
			Else
				Dim w As Map
				w.Initialize
				w.put("Id", mFlugzeug.MyId)
				DBUtils.UpdateRecord2(Main.SQL1, "Flugzeuge",m,w)
				Activity.Finish
			End If
	End Select	
End Sub

Sub evDelete_Click
	Msgbox2Async("Flugzeug wirklich löschen?", "Warnung", "Ja", "", "Nein", LoadBitmap(File.DirAssets, "warning.png"),False)
	Wait For Msgbox_result(Result As Int)
	If Result = DialogResponse.Positive Then
		Dim m As Map
		m.Initialize
		m.Put("Id", mFlugzeug.MyId)
		DBUtils.DeleteRecord(Main.SQL1, "Flugzeuge", m)
		Activity.Finish
	Else
		Activity.Finish
	End If
End Sub

Sub Validate () As Boolean	
	Dim myBool As Boolean
	myBool = True
	sb.Initialize
	
	If edtFlugzeug.Text.Length=0 Then
		edtFlugzeug.Text="Flgz"
		myBool=False
		sb.Append("Flugzeug ist Pflichtfeld").Append(CRLF)
	End If
	If edtKennzeichen.Text.Length=0 Then
		edtKennzeichen.Text="D-1234"
		myBool=False
		sb.Append("Kennzeichen ist Pflichtfeld").Append(CRLF)
	End If
	If edtBemerkung.Text.Length=0 Then
		edtBemerkung.Text="nz"
		myBool=False
		sb.Append("Bemerkung ist Pflichtfeld").Append(CRLF)
	End If
	If edtFlugzeugNr.Text.Length=0 Then
		edtFlugzeugNr.Text="0"
		myBool=False
		sb.Append("Nr ist Pflichtfeld").Append(CRLF)
	End If
		
	'Ende
	If myBool=False Then
		sb=sb.Append(CRLF)
		sb=sb.Append("Bitte korrigieren!").Append(CRLF)
	End If
	Return myBool
End Sub
	
