﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.28
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
	Private scvInputStart As ScrollView
	Private pnlstartinput As Panel
	Private lblDatum1 As Label
	Private lblDatum2 As Label
	Private lblPilot As Label
	Private edtPilotIch As EditText
	Private lblBegleiter As Label
	Private edtPilotBegleit As EditText
	Private lblFlugzeug As Label
	Private pnlFlgz As Panel
	Private spiFlgz As Spinner
	Private lblStartzeit1 As Label
	Private lblStartzeit2 As Label
	Private lblLandezeit1 As Label
	Private lblLandezeit2 As Label
	Private lblAnzahlStarts As Label
	Private edtAnzahlStarts As EditText
	Private lblSammelFlugzeit As Label
	Private edtSammelFlugzeit As EditText
	Private lblStartart As Label
	Private pnlStartart As Panel
	Private spiStartart As Spinner
	Private lblFlugtyp As Label
	Private pnlFlugtyp As Panel
	Private spiFlugtyp As Spinner
	Private lblVon As Label
	Private edtVon As EditText
	Private lblNach As Label
	Private edtNach As EditText
	Private lblStrecke As Label
	Private edtStrecke As EditText
	Private lblBemerkung As Label
	Private edtBemerkung As EditText
	Private lblID As Label
	Private lblFlugzeugID As Label
	Private lblStartartID As Label
	Private lblFlugtypID As Label
	
	Private lFlugzeug As List
	Private lKennzeichen As List
	Private lFlugzeugID As List
	Private lStartart As List
	Private lStartartID As List
	Private lFlugtyp As List
	Private lFlugtypID As List
	Private lPicDual As List
		
	Dim TimeDialog As TimePickerDialog
	Dim DateDialog As DatePickerDialog
	Dim dtx As Int
	Dim myStarts As Int
	Dim myFlugzeit As Int
	Private mFlight As FData
	
	Dim sb As StringBuilder
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	'Activity.LoadLayout("Layout1")
	
	Activity.LoadLayout("LayoutMainInput")
	
	scvInputStart.Panel.LoadLayout("LayoutMainInputSCV")
	scvInputStart.Panel.Height = pnlstartinput.Height
	
	Dim myLong As Long
	myLong=DateTime.Now
	TimeDialog.Initialize("evTimeDialog",10,0,True)
	DateDialog.Initialize("evDateDialog",DateTime.GetYear(myLong),DateTime.GetMonth(myLong)-1,DateTime.GetDayOfMonth(myLong))
	Dim cal As Calendar
	cal.Initialize("dd.MM.yyyy",cal.GERMAN,"1.1.1970")
	DateDialog.MinDate = cal
	
	'TimeDialog.show("myTime")
	TimeDialog.setTimeInterval2(1,1)
	
	Log(DateTime.DeviceDefaultTimeFormat)
	Log (DateTime.getmonth(myLong))
	
	Select Main.cADE
		Case 1
			Activity.Title="Start Hinzufügen"
			Activity.TitleColor=Colors.Blue
			Activity.AddMenuItem3("Add", "evClick", LoadBitmap(File.DirAssets, "Add.png"),True)
			InitAdd
		Case 2
			Activity.Title="Start ändern/löchen"
			Activity.TitleColor=Colors.Blue
			Activity.AddMenuItem3("Delete", "evDelete", LoadBitmap(File.DirAssets, "Delete.png"),True)
			Activity.AddMenuItem3("Edit", "evClick", LoadBitmap(File.DirAssets, "Edit.png"),True)
			InitEditDelete
	End Select
		
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub InitAdd
	
	Dim cd As ColorDrawable
	cd.Initialize2(Colors.Transparent, 5dip, 1dip, Colors.LightGray)
	Dim cd1 As ColorDrawable
	cd1.Initialize2(Colors.Transparent, 5dip, 1dip, Colors.Transparent)
	
	mFlight.Initialize

	'Initialisiere Datum
	DateTime.DateFormat="EE dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	lblDatum1.Background=cd1
	lblDatum1.Text="Datum"
	lblDatum2.Background=cd
	lblDatum2.Text=DateTime.Date(Main.cDate)
	dtx=1
	mFlight.fDatum=Main.cDate

	'Initialisiere Pilot Ich
	lblPilot.Background=cd1
	lblPilot.Text="Pilot"
	edtPilotIch.Background=cd
	edtPilotIch.Text="Brodmuehler R"
	mFlight.fPilot=edtPilotIch.Text

	'Iniialisiere Begleitung
	lblBegleiter.Background=cd1
	lblBegleiter.Text="Begleiter"
	edtPilotBegleit.Background=cd
	edtPilotBegleit.Text="nz"
	mFlight.fBegleiter=edtPilotBegleit.Text
	
	'Initialisiere Flugzeug
	lblFlugzeugID.Text=""
	lblFlugzeug.Background=cd1
	lblFlugzeug.Text="Flugzeug"
	pnlFlgz.Background=cd
	Dim cur As Cursor
	Dim i As Int
	cur = Main.SQL1.ExecQuery("SELECT * FROM Flugzeuge ORDER BY Nr")
	cur.Position=0
	If cur.RowCount=0 Or cur.GetString("Flugzeug")=Null Then
		ToastMessageShow("Bitte erst Flugzeuge anlegen!",False)
		mFlight.fFlugzeug=""
		mFlight.fKennzeichen=""
		mFlight.fFlugzeugID=-1
	Else
		lFlugzeug.Initialize
		lKennzeichen.Initialize
		lFlugzeugID.Initialize
		cur.Position=0
		For i=0 To cur.RowCount-1
			cur.Position=i
			Dim st As String
			st=cur.GetString("Flugzeug") & " (" & cur.GetString("Kennzeichen") & ")"
			spiFlgz.Add(st)
			lFlugzeug.Add(cur.GetString("Flugzeug"))
			lKennzeichen.Add(cur.GetString("Kennzeichen"))
			lFlugzeugID.Add(cur.GetString("Id"))
		Next
		spiFlgz.SelectedIndex=0
		mFlight.fFlugzeug=lFlugzeug.Get(spiFlgz.SelectedIndex)
		mFlight.fKennzeichen=lKennzeichen.Get(spiFlgz.SelectedIndex)
		mFlight.fFlugzeugID=lFlugzeugID.Get(spiFlgz.SelectedIndex)
	End If

	
	'Initialisiere Anzahl Starts
	lblAnzahlStarts.Background=cd1
	lblAnzahlStarts.Text="Anzahl Starts"
	edtAnzahlStarts.Background=cd
	edtAnzahlStarts.Text="1"
	myStarts=1
	mFlight.fStarts=myStarts
	edtSammelFlugzeit.Enabled=False
	
	'Initialisiere Startzeit
	lblStartzeit1.Background=cd1
	lblStartzeit1.Text="Startzeit UTC (hh:mm)"
	lblStartzeit2.Background=cd
	DateTime.DateFormat="dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	DateTime.timeformat="HH:mm"
	lblStartzeit2.Text="08:00"
	dtx = 2
	mFlight.fStartzeit=DateTime.DateTimeParse(DateTime.Date(DateTime.Now),"08:00")
		
	'Initialisiere Landezeit
	lblLandezeit1.Background=cd1
	lblLandezeit1.Text="Landezeit UTC (hh:mm)"
	lblLandezeit2.Background=cd
	DateTime.DateFormat="dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	DateTime.timeformat="HH:mm"
	lblLandezeit2.Text="08:00"
	dtx = 3
	mFlight.fLandezeit=DateTime.DateTimeParse(DateTime.Date(DateTime.Now),"08:00")

	'Initialisiere Flugzeit
	lblSammelFlugzeit.Background=cd1
	lblSammelFlugzeit.Text="Flugzeit (min)"
	edtSammelFlugzeit.Background=cd
	edtSammelFlugzeit.Text="0"
	myFlugzeit=0
	mFlight.fFlugzeit=myFlugzeit
		
	'Initialisiere Startart
	lblStartartID.Text=""
	lblStartart.Background=cd1
	lblStartart.Text="Startart"
	pnlStartart.Background=cd
	Dim cur As Cursor
	Dim i As Int
	cur = Main.SQL1.ExecQuery("SELECT * FROM Startart ORDER BY Nr")
	cur.Position=0
	If cur.RowCount=0 Or cur.GetString("Startart")=Null Then
		ToastMessageShow("Bitte Startart anlegen!",False)
		mFlight.fStartart=""
		mFlight.fStartartID=-1
	Else
		lStartart.Initialize
		lStartartID.Initialize
		cur.Position=0
		For i=0 To cur.RowCount-1
			cur.Position=i
			Dim st As String
			st=cur.GetString("Startart")
			spiStartart.Add(st)
			lStartart.Add(cur.GetString("Startart"))
			lStartartID.Add(cur.GetString("Id"))
		Next
		spiStartart.SelectedIndex=0
	End If
	mFlight.fStartart=lStartart.Get(spiStartart.SelectedIndex)
	mFlight.fStartartID=lStartartID.Get(spiStartart.SelectedIndex)
	
	'Initialisere Flugtyp
	lblFlugtypID.Text=""
	lblFlugtyp.Background=cd1
	lblFlugtyp.Text="Flugtyp"
	pnlFlugtyp.Background=cd
	Dim cur As Cursor
	Dim i As Int
	cur = Main.SQL1.ExecQuery("SELECT * FROM Flugtyp ORDER BY Nr")
	cur.Position=0
	If cur.RowCount=0 Or cur.GetString("Flugtyp")=Null Then
		ToastMessageShow("Bitte Flugtyp anlegen!",False)
		mFlight.fFlugtyp=""
		mFlight.fFlugtypID=-1
		mFlight.fPicDual=-1
	Else
		lFlugtyp.Initialize
		lFlugtypID.Initialize
		lPicDual.Initialize
		cur.Position=0
		For i=0 To cur.RowCount-1
			cur.Position=i
			Dim st As String
			st=cur.GetString("Flugtyp") & " (" & cur.GetString("PicDual") & ")"
			spiFlugtyp.Add(st)
			lFlugtyp.Add(cur.GetString("Flugtyp"))
			lFlugtypID.Add(cur.GetString("Id"))
			lPicDual.Add(cur.GetString("PicDual"))
		Next
		spiFlugtyp.SelectedIndex=0
	End If
	mFlight.fFlugtyp=lFlugtyp.Get(spiFlugtyp.SelectedIndex)
	mFlight.fFlugtypID=lFlugtypID.Get(spiFlugtyp.SelectedIndex)
	mFlight.fPicDual=Functions.Pic2Int(lPicDual.Get(spiFlugtyp.SelectedIndex))
	
	'Initialisiere Von
	lblVon.Background=cd1
	lblVon.Text="Von"
	edtVon.Background=cd
	edtVon.Text="Reinsdorf"
	mFlight.fVon=edtVon.Text
	
	'Intialisiere Nach
	lblNach.Background=cd1
	lblNach.Text="Nach"
	edtNach.Background=cd
	edtNach.Text="Reinsdorf"
	mFlight.fNach=edtNach.Text
	
	'Initialisiere Strecke
	lblStrecke.Background=cd1
	lblStrecke.Text="Strecke in km"
	edtStrecke.Background=cd
	edtStrecke.Text="0"
	mFlight.fStrecke=edtStrecke.Text
	
	'Initialisiere Bemerkung
	lblBemerkung.Background=cd1
	lblBemerkung.Text="Bemerkung"
	edtBemerkung.Background=cd
	edtBemerkung.Text="nz"
	mFlight.fBemerkung=edtBemerkung.Text
	
End Sub

Sub InitEditDelete
	
	Dim cd As ColorDrawable
	cd.Initialize2(Colors.Transparent, 5dip, 1dip, Colors.LightGray)
	Dim cd1 As ColorDrawable
	cd1.Initialize2(Colors.Transparent, 5dip, 1dip, Colors.Transparent)
	
	mFlight.Initialize
	
	'ID
	mFlight.fId=Main.cFlight.fId

	'Datum
	DateTime.DateFormat="EE dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	lblDatum1.Background=cd1
	lblDatum1.Text="Datum"
	lblDatum2.Background=cd
	lblDatum2.Text=DateTime.Date(Main.cFlight.fDatum)
	dtx=1
	mFlight.fDatum=Main.cFlight.fDatum

	'Pilot Ich
	lblPilot.Background=cd1
	lblPilot.Text="Pilot"
	edtPilotIch.Background=cd
	edtPilotIch.Text=Main.cFlight.fPilot
	mFlight.fPilot=Main.cFlight.fPilot

	'Begleitung
	lblBegleiter.Background=cd1
	lblBegleiter.Text="Begleiter"
	edtPilotBegleit.Background=cd
	edtPilotBegleit.Text=Main.cFlight.fBegleiter
	mFlight.fBegleiter=Main.cFlight.fBegleiter
	
	'Flugzeug
	lblFlugzeugID.Text=""
	lblFlugzeug.Background=cd1
	lblFlugzeug.Text="Flugzeug"
	pnlFlgz.Background=cd
	Dim cur As Cursor
	Dim i As Int
	cur = Main.SQL1.ExecQuery("SELECT * FROM Flugzeuge ORDER BY Nr")
	cur.Position=0
	If cur.RowCount=0 Or cur.GetString("Flugzeug")=Null Then
		ToastMessageShow("Bitte erst Flugzeuge anlegen!",False)
		mFlight.fFlugzeug=""
		mFlight.fKennzeichen=""
		mFlight.fFlugzeugID=-1
	Else
		lFlugzeug.Initialize
		lKennzeichen.Initialize
		lFlugzeugID.Initialize
		cur.Position=0
		For i=0 To cur.RowCount-1
			cur.Position=i
			Dim st As String
			st=cur.GetString("Flugzeug") & " (" & cur.GetString("Kennzeichen") & ")"
			spiFlgz.Add(st)
			lFlugzeug.Add(cur.GetString("Flugzeug"))
			lKennzeichen.Add(cur.GetString("Kennzeichen"))
			lFlugzeugID.Add(cur.GetString("Id"))
		Next
		Dim i, mydum As Int
		For i=0 To lFlugzeugID.Size-1
			Log (lFlugzeugID.Get(i) & "-" & Main.cFlight.fFlugzeugID)
			mydum=lFlugzeugID.Get(i)
			If mydum = Main.cFlight.fFlugzeugID Then
				spiFlgz.SelectedIndex=i
			End If
		Next
		mFlight.fFlugzeug=Main.cFlight.fFlugzeug
		mFlight.fKennzeichen=Main.cFlight.fKennzeichen
		mFlight.fFlugzeugID=Main.cFlight.fFlugzeugID
	End If
	
	'Anzahl Starts
	lblAnzahlStarts.Background=cd1
	lblAnzahlStarts.Text="Anzahl Starts"
	edtAnzahlStarts.Background=cd
	edtAnzahlStarts.Text=Main.cFlight.fStarts
	mFlight.fStarts=Main.cFlight.fStarts
	myStarts=Main.cFlight.fStarts
	If myStarts = 1 Then
		edtSammelFlugzeit.Enabled=False
	Else
		edtSammelFlugzeit.Enabled=True
	End If		
	
	'Startzeit
	lblStartzeit1.Background=cd1
	lblStartzeit1.Text="Startzeit UTC (hh:mm)"
	lblStartzeit2.Background=cd
	DateTime.DateFormat="dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	DateTime.timeformat="HH:mm"
	lblStartzeit2.Text=DateTime.Time(Main.cFlight.fStartzeit)
	dtx=2
	mFlight.fStartzeit=Main.cFlight.fStartzeit
			
	'Landezeit
	lblLandezeit1.Background=cd1
	lblLandezeit1.Text="Landezeit UTC (hh:mm)"
	lblLandezeit2.Background=cd
	DateTime.DateFormat="dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	DateTime.timeformat="HH:mm"
	lblLandezeit2.Text=DateTime.Time(Main.cFlight.fLandezeit)
	dtx=3
	mFlight.fLandezeit = Main.cFlight.fLandezeit

	'Flugzeit
	lblSammelFlugzeit.Background=cd1
	lblSammelFlugzeit.Text="Flugzeit (min)"
	edtSammelFlugzeit.Background=cd
	edtSammelFlugzeit.Text=NumberFormat2(Main.cFlight.fFlugzeit/1000/60,0,0,0,False)
	mFlight.fFlugzeit=Main.cFlight.fFlugzeit
	myFlugzeit=Main.cFlight.fFlugzeit
		
	'Startart
	lblStartartID.Text=""
	lblStartart.Background=cd1
	lblStartart.Text="Startart"
	pnlStartart.Background=cd
	Dim cur As Cursor
	Dim i As Int
	cur = Main.SQL1.ExecQuery("SELECT * FROM Startart ORDER BY Nr")
	cur.Position=0
	If cur.RowCount=0 Or cur.GetString("Startart")=Null Then
		ToastMessageShow("Bitte Startart anlegen!",False)
		mFlight.fStartart=""
		mFlight.fStartartID=-1
	Else
		lStartart.Initialize
		lStartartID.Initialize
		cur.Position=0
		For i=0 To cur.RowCount-1
			cur.Position=i
			Dim st As String
			st=cur.GetString("Startart")
			spiStartart.Add(st)
			lStartart.Add(cur.GetString("Startart"))
			lStartartID.Add(cur.GetString("Id"))
		Next
	End If
	Dim i, mydum As Int
	For i=0 To lStartartID.Size-1
		mydum=lStartartID.Get(i)
		If mydum = Main.cFlight.fStartartID Then
			spiStartart.SelectedIndex=i
		End If
	Next
	mFlight.fStartart=Main.cFlight.fStartart
	mFlight.fStartartID=Main.cFlight.fStartartID
	
	'Flugtyp
	lblFlugtypID.Text=""
	lblFlugtyp.Background=cd1
	lblFlugtyp.Text="Flugtyp"
	pnlFlugtyp.Background=cd
	Dim cur As Cursor
	Dim i As Int
	cur = Main.SQL1.ExecQuery("SELECT * FROM Flugtyp ORDER BY Nr")
	cur.Position=0
	If cur.RowCount=0 Or cur.GetString("Flugtyp")=Null Then
		ToastMessageShow("Bitte Flugtyp anlegen!",False)
		mFlight.fFlugtyp=""
		mFlight.fFlugtypID=-1
		mFlight.fPicDual=-1
	Else
		lFlugtyp.Initialize
		lFlugtypID.Initialize
		lPicDual.Initialize
		cur.Position=0
		For i=0 To cur.RowCount-1
			cur.Position=i
			Dim st As String
			st=cur.GetString("Flugtyp") & " (" & cur.GetString("PicDual") & ")"
			spiFlugtyp.Add(st)
			lFlugtyp.Add(cur.GetString("Flugtyp"))
			lFlugtypID.Add(cur.GetString("Id"))
			lPicDual.Add(cur.GetString("PicDual"))
			Log (i & "-" & lFlugtyp.Get(i) & "-" & lFlugtyp.Get(i) & "-" & spiFlugtyp.GetItem(i))
		Next
	End If
	Dim i, mydum As Int
	For i=0 To lFlugtypID.Size-1
		mydum=lFlugtypID.Get(i)
		Log (i & "-" & mydum)
		If mydum = Main.cFlight.fFlugtypID Then
			spiFlugtyp.SelectedIndex=i
		End If
	Next
	mFlight.fFlugtyp=Main.cFlight.fFlugtyp
	mFlight.fFlugtypID=Main.cFlight.fFlugtypID
	mFlight.fPicDual=Main.cFlight.fPicDual
	
	'Von
	lblVon.Background=cd1
	lblVon.Text="Von"
	edtVon.Background=cd
	edtVon.Text=Main.cFlight.fVon
	mFlight.fVon=Main.cFlight.fVon
	
	'Nach
	lblNach.Background=cd1
	lblNach.Text="Nach"
	edtNach.Background=cd
	edtNach.Text=Main.cFlight.fNach
	mFlight.fNach=Main.cFlight.fNach
	
	'Strecke
	lblStrecke.Background=cd1
	lblStrecke.Text="Strecke in km"
	edtStrecke.Background=cd
	edtStrecke.Text=Main.cFlight.fStrecke
	mFlight.fStrecke=Main.cFlight.fStrecke
	
	'Bemerkung
	lblBemerkung.Background=cd1
	lblBemerkung.Text="Bemerkung"
	edtBemerkung.Background=cd
	edtBemerkung.Text=Main.cFlight.fBemerkung
	mFlight.fBemerkung=Main.cFlight.fBemerkung
	
End Sub

Sub edtPilotIch_FocusChanged (HasFocus As Boolean)
	Dim myIME As IME
	myIME.Initialize("evIME")
	myIME.AddHeightChangedEvent
			
	If HasFocus = True Then
		myIME.ShowKeyboard(edtPilotIch)
	Else
		myIME.HideKeyboard
		If edtPilotIch.Text.Length=0 Then
			edtPilotIch.Text="Brodmuehler R"
		End If
		mFlight.fPilot=edtPilotIch.Text
	End If
	
End Sub

Sub edtPilotBegleit_FocusChanged (HasFocus As Boolean)
	Dim myIME As IME
	myIME.Initialize("evIME")
	myIME.AddHeightChangedEvent
			
	If HasFocus = True Then
		myIME.ShowKeyboard(edtPilotBegleit)
	Else
		myIME.HideKeyboard
		If edtPilotBegleit.Text.Length=0 Then
			edtPilotBegleit.Text="nz"
		End If
		mFlight.fBegleiter=edtPilotBegleit.Text
	End If
	
End Sub

Sub spiFlgz_ItemClick (Position As Int, Value As Object)
	mFlight.fFlugzeug=lFlugzeug.Get(Position)
	mFlight.fKennzeichen=lKennzeichen.Get(Position)
	mFlight.fFlugzeugID=lFlugzeugID.Get(Position)
End Sub

Sub edtAnzahlStarts_TextChanged (Old As String, New As String)
	Dim myIME As IME
	myIME.Initialize("evIME")
	myIME.AddHeightChangedEvent
	
	If New.Length=0 Then
		myIME.SetCustomFilter(edtAnzahlStarts,edtAnzahlStarts.INPUT_TYPE_NUMBERS,"123456789")
		myStarts=NumberFormat2(0,0,0,0,False)
	Else
		myIME.SetCustomFilter(edtAnzahlStarts,edtAnzahlStarts.INPUT_TYPE_NUMBERS,"0123456789")
		myStarts=NumberFormat2(New,0,0,0,False)
	End If
	mFlight.fStarts=myStarts
	
	If myStarts = 1 Then
		edtSammelFlugzeit.Enabled=False
	Else
		edtSammelFlugzeit.Enabled=True
	End If
		
End Sub

Sub edtAnzahlStarts_FocusChanged (HasFocus As Boolean)
	Dim myIME As IME
	myIME.Initialize("evIME")
	myIME.AddHeightChangedEvent
		
	If HasFocus=True Then
		myIME.SetCustomFilter(edtAnzahlStarts,edtAnzahlStarts.INPUT_TYPE_NUMBERS,"0123456789")
		myIME.ShowKeyboard(edtAnzahlStarts)
	Else
		edtAnzahlStarts.Text=NumberFormat2(myStarts,0,0,0,False)
		If myStarts=1 Then
			SetFlugzeit(mFlight.fStartzeit,mFlight.fLandezeit)
		End If
	End If
	
End Sub

Sub edtSammelFlugzeit_TextChanged (Old As String, New As String)
	Dim myIME As IME
	myIME.Initialize("evIME")
	myIME.AddHeightChangedEvent
	
	If IsNumber(New)=False Then
		myFlugzeit=0
	else if New.Length=0 Then
		myIME.SetCustomFilter(edtSammelFlugzeit,edtSammelFlugzeit.INPUT_TYPE_NUMBERS,"123456789")
		myFlugzeit=NumberFormat2(0,0,0,0,False)
	Else
		myIME.SetCustomFilter(edtSammelFlugzeit,edtSammelFlugzeit.INPUT_TYPE_NUMBERS,"0123456789")
		myFlugzeit=NumberFormat2(New*60*1000,0,0,0,False)
	End If
	mFlight.fFlugzeit=myFlugzeit
	
End Sub

Sub edtSammelFlugzeit_FocusChanged (HasFocus As Boolean)
	
	Dim myIME As IME
	myIME.Initialize("evIME")
	myIME.AddHeightChangedEvent
		
	If HasFocus=True Then
		myIME.ShowKeyboard(edtSammelFlugzeit)
	Else
		edtSammelFlugzeit.Text=NumberFormat2(myFlugzeit/1000/60,0,0,0,False)
		myIME.HideKeyboard
	End If
	
End Sub

Sub spiStartart_ItemClick (Position As Int, Value As Object)
	mFlight.fStartart=lStartart.Get(Position)
	mFlight.fStartartID=lStartartID.Get(Position)
End Sub

Sub spiFlugtyp_ItemClick (Position As Int, Value As Object)
	mFlight.fFlugtyp=lFlugtyp.Get(Position)
	mFlight.fFlugtypID=lFlugtypID.Get(Position)
	mFlight.fPicDual=Functions.Pic2Int(lPicDual.Get(Position))
End Sub

Sub edtVon_FocusChanged (HasFocus As Boolean)
	Dim myIME As IME
	myIME.Initialize("evIME")
	myIME.AddHeightChangedEvent
			
	If HasFocus = True Then
		myIME.ShowKeyboard(edtVon)
	Else
		myIME.HideKeyboard
		If edtVon.Text.Length=0 Then
			edtVon.Text="nz"
		End If
		mFlight.fVon=edtVon.Text
	End If
	
End Sub

Sub edtNach_FocusChanged (HasFocus As Boolean)
	Dim myIME As IME
	myIME.Initialize("evIME")
	myIME.AddHeightChangedEvent
			
	If HasFocus = True Then
		myIME.ShowKeyboard(edtNach)
	Else
		myIME.HideKeyboard
		If edtNach.Text.Length=0 Then
			edtNach.Text="nz"
		End If
		mFlight.fNach=edtNach.Text
	End If
	
End Sub

Sub edtStrecke_TextChanged (Old As String, New As String)
	Dim myIME As IME
	myIME.Initialize("evIME")
	myIME.AddHeightChangedEvent
	
	If New.Length=0 Then
		myIME.SetCustomFilter(edtStrecke,edtStrecke.INPUT_TYPE_NUMBERS,"123456789")
	Else
		myIME.SetCustomFilter(edtStrecke,edtStrecke.INPUT_TYPE_NUMBERS,"0123456789")
	End If
	
End Sub

Sub edtStrecke_FocusChanged (HasFocus As Boolean)
	Dim myIME As IME
	myIME.Initialize("evIME")
	myIME.AddHeightChangedEvent
		
	If HasFocus=True Then
		myIME.SetCustomFilter(edtStrecke,edtStrecke.INPUT_TYPE_NUMBERS,"0123456789")
		myIME.ShowKeyboard(edtStrecke)
	Else
		myIME.HideKeyboard
		If edtStrecke.Text.Length=0 Then
			edtStrecke.Text=0
		End If
		mFlight.fStrecke=edtStrecke.Text
	End If
	
End Sub

Sub edtBemerkung_FocusChanged (HasFocus As Boolean)
	Dim myIME As IME
	myIME.Initialize("evIME")
	myIME.AddHeightChangedEvent
		
	If HasFocus=True Then
		'myIME.SetCustomFilter(edtBemerkung,edtBemerkung.INPUT_TYPE_NUMBERS,"0123456789")
		myIME.ShowKeyboard(edtBemerkung)
	Else
		myIME.HideKeyboard
		If edtBemerkung.Text.Length=0 Then
			edtBemerkung.Text="nz"
		Else If edtBemerkung.Text.Length>30 Then
			edtBemerkung.Text=edtBemerkung.Text.SubString2(0,30)
		End If
		mFlight.fBemerkung=edtBemerkung.Text
		edtBemerkung.Text=mFlight.fBemerkung
	End If
End Sub

Private Sub evIME_HeightChanged (NewHeight As Int, OldHeight As Int)
	scvInputStart.Height=NewHeight
End Sub

Sub evIME_click
	
End Sub

Sub lblDatum2_Click
	
	Dim mylong As Long = mFlight.fDatum
	dtx=1
	DateDialog.Initialize("evDateDialog",DateTime.GetYear(mylong),DateTime.GetMonth(mylong)-1,DateTime.GetDayOfMonth(mylong))
	Dim cal As Calendar
	cal.Initialize("dd.MM.yyyy",cal.GERMAN,"1.1.1970")
	DateDialog.MinDate = cal
	cal.Initialize("dd.MM.yyyy",cal.GERMAN,"31.12.2030")
	DateDialog.MaxDate = cal
	
	DateDialog.show("myDatum")
	
End Sub

Sub evDateDialog_onDateSet(year As Int, monthOfYear As Int,	dayOfmonth As Int)
	
	Dim myYear, myMonthOfYear, myDayOfMonth As Int
	myYear=year
	myMonthOfYear=monthOfYear+1
	myDayOfMonth=dayOfmonth
	
	dtx=1
	Log($"onDateSet(${myYear},${myMonthOfYear},${myDayOfMonth})"$)
	Dim d As Long
	DateTime.DateFormat = "dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	Log (NumberFormat2(myDayOfMonth,2,0,0,False) & "." & NumberFormat2(myMonthOfYear,2,0,0,False) & "." & NumberFormat2(myYear,4,0,0,False))
	d = DateTime.DateParse(NumberFormat2(myDayOfMonth,2,0,0,False) & "." & NumberFormat2(myMonthOfYear,2,0,0,False) & "." & NumberFormat2(myYear,4,0,0,False))
	Log (DateTime.Date(d))
	Log (d)
	Main.cDate=d
	TimeDate(d)
	
End Sub

Sub evDateDialog_onCancel()
	Log("Date_onCancel")
End Sub

Sub evDateDialog_onDismiss()
	Log("Date_onDismiss")
End Sub


Sub lblStartzeit2_Click
	
	Dim mylong As Long = mFlight.fStartzeit
	dtx=2
	TimeDialog.Initialize("evTimeDialog",DateTime.GetHour(mylong),DateTime.GetMinute(mylong),True)
		
	TimeDialog.show("myTime")
	
End Sub

Sub lblLandezeit2_Click
	
	Dim mylong As Long = mFlight.fLandezeit
	dtx=3
	TimeDialog.Initialize("evTimeDialog",DateTime.GetHour(mylong),DateTime.GetMinute(mylong),True)
		
	TimeDialog.show("myTime")
	
End Sub



Sub evTimeDialog_onTimeSet(hour As Int,minute As Int, second As Int)
	
	Dim myHour, myMin As Int
	
	myHour=hour
	myMin=minute
	
	Log($"ontimeSet(${hour},${minute},${second})"$)
	Dim d As Long
	DateTime.DateFormat = "dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	DateTime.TimeFormat = "HH:mm"
	Dim dStr, tStr As String
	dStr=DateTime.Date(mFlight.fDatum)
	tStr=NumberFormat2(myHour,2,0,0,False) & ":" & NumberFormat2(myMin,2,0,0,False)
	Log (dStr)
	Log (tStr)
	d = DateTime.DateTimeParse(dStr,tStr)
	
	TimeDate(d)
	If myStarts=1 Then
		SetFlugzeit(mFlight.fStartzeit,mFlight.fLandezeit)
	End If
	
End Sub

Sub evTimeDialog_onCancel()
	Log("Time_onCancel")
End Sub

Sub evTimeDialog_onDismiss()
	Log("Time_onDismiss")
End Sub


Sub TimeDate (md As Long)

	Select dtx
		Case 1 'Datum
			mFlight.fDatum=md
			DateTime.DateFormat = "EE dd.MM.yyyy"
			DateTime.SetTimeZone(0)
			lblDatum2.Text = DateTime.Date(mFlight.fDatum)
			DateTime.TimeFormat = "HH:mm"
			DateTime.DateFormat = "dd.MM.yyyy"
			mFlight.fStartzeit=DateTime.DateTimeParse(DateTime.Date(mFlight.fDatum),DateTime.Time(mFlight.fStartzeit))
			mFlight.fLandezeit=DateTime.DateTimeParse(DateTime.Date(mFlight.fDatum),DateTime.Time(mFlight.fLandezeit))
			Log (DateTime.Date(mFlight.fDatum))
			Log (DateTime.date(mFlight.fDatum) & "-" & DateTime.Time(mFlight.fStartzeit))
			Log (DateTime.date(mFlight.fDatum) & "-" & DateTime.Time(mFlight.fLandezeit))
			
		Case 2 'Startzeit
			DateTime.TimeFormat = "HH:mm"
			DateTime.DateFormat = "dd.MM.yyyy"
			mFlight.fStartzeit=DateTime.DateTimeParse(DateTime.Date(mFlight.fDatum),DateTime.Time(md))
			mFlight.fLandezeit=DateTime.DateTimeParse(DateTime.Date(mFlight.fDatum),DateTime.Time(mFlight.fLandezeit))
			lblStartzeit2.Text=DateTime.Time(mFlight.fStartzeit)
			Log (mFlight.fDatum)
			Log (DateTime.date(mFlight.fDatum) & "-" & DateTime.Time(mFlight.fStartzeit))
			Log (DateTime.date(mFlight.fDatum) & "-" & DateTime.Time(mFlight.fLandezeit))
		Case 3 'Landzeit
			DateTime.TimeFormat = "HH:mm"
			DateTime.DateFormat = "dd.MM.yyyy"
			mFlight.fStartzeit=DateTime.DateTimeParse(DateTime.Date(mFlight.fDatum),DateTime.Time(mFlight.fStartzeit))
			mFlight.fLandezeit=DateTime.DateTimeParse(DateTime.Date(mFlight.fDatum),DateTime.Time(md))
			lblLandezeit2.Text=DateTime.Time(mFlight.fLandezeit)
			Log (mFlight.fDatum)
			Log (DateTime.date(mFlight.fDatum) & "-" & DateTime.Time(mFlight.fStartzeit))
			Log (DateTime.date(mFlight.fDatum) & "-" & DateTime.Time(mFlight.fLandezeit))
	End Select
		
End Sub

Sub SetFlugzeit(Startzeit As Long, Landezeit As Long)
	
	Log (DateTime.date(Startzeit) & "," &  DateTime.date(Landezeit))
	Log (DateTime.time(Startzeit) & "," &  DateTime.time(Landezeit))
	myFlugzeit=Landezeit-Startzeit
	mFlight.fFlugzeit=NumberFormat2(myFlugzeit,0,0,0,False)
	edtSammelFlugzeit.Text=NumberFormat2(myFlugzeit/1000/60,0,0,0,False)
	
End Sub

Sub Validate () As Boolean
		
	Dim myBool As Boolean
	myBool = True
	sb.Initialize
		
	'Datum
	DateTime.DateFormat = "EE dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	DateTime.TimeFormat = "HH:mm"
	lblDatum2.text=DateTime.Date(mFlight.fDatum)
	
	'Starts
	edtAnzahlStarts.Text=NumberFormat2(myStarts,0,0,0,False)
	If myStarts=0 Then
		myBool=False
		sb=sb.Append("Anzahl Starts muss größer als 0 sein!").Append(CRLF)
	else If myStarts=1 Then
		SetFlugzeit(mFlight.fStartzeit,mFlight.fLandezeit)
	End If	
	
	'Startzeit, Landezeit
	DateTime.DateFormat = "EE dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	DateTime.TimeFormat = "HH:mm"
	Dim cur As Cursor
	Dim myQuery As String
	Select Main.cADE
		Case 1	'Neuer Flug
			myQuery = "SELECT * FROM Fluege "
			myQuery = myQuery & "WHERE (Startzeit='" & mFlight.fStartzeit & "') "
		Case 2	'Edit Flug
			myQuery = "SELECT * FROM Fluege "
			myQuery = myQuery & "WHERE (Startzeit='" & mFlight.fStartzeit & "') "
			myQuery = myQuery & "AND (Id <> '" & mFlight.fId & "')"
	End Select
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount <> 0 Then
		Log (mFlight.fStartzeit)
		Log (cur.GetString("Startzeit"))
		myBool=False
		sb=sb.Append("Flüge mit gleichem Datum/Startzeit geht nicht").Append(CRLF)
	End If
	If mFlight.fStartzeit >= mFlight.fLandezeit Then
		myBool = False
		sb=sb.Append("Landezeit kann nicht gleich oder vor der Startzeit sein!").Append(CRLF)
	Else
		lblStartzeit2.Text=DateTime.Time(mFlight.fStartzeit)
		lblLandezeit2.Text=DateTime.Time(mFlight.fLandezeit)
	End If
	
	'Flugzeit
	edtSammelFlugzeit.text=NumberFormat2(myFlugzeit/1000/60,0,0,0,False)
	If myFlugzeit<=0 Then
		myBool=False
		sb=sb.Append("Flugzeit muß größer als 0 Min sein!!").Append(CRLF)
	End If
	
	'Pilot
	Dim a As Int
	a=edtPilotIch.Text.Length
	If a=0 Then
		myBool=False
		sb=sb.Append("Piloten angeben!").Append(CRLF)
		edtPilotIch.Text="Brodmuehler R"
	Else
		mFlight.fPilot=edtPilotIch.text
		edtPilotIch.text=mFlight.fPilot
	End If	
	
	'Begleiter
	Dim a As Int
	a=edtPilotBegleit.Text.Length
	If a=0 Then
		mFlight.fBegleiter="nz"
		edtPilotBegleit.Text="nz"
	Else
		mFlight.fBegleiter=edtPilotBegleit.Text
		edtPilotBegleit.Text=mFlight.fBegleiter
	End If
	
	'Kennzeichen, Flugzeug, FlugzeugID keine Validierung notwendig
	
	'Startart, StartartID keine Validierung notwendig
		
	'Flugtyp, FlugtypID, PicDual keine Validierung notwendig

	'Von
	Dim a As Int
	a=edtVon.Text.Length
	If a=0 Then
		mFlight.fVon="nz"
		edtVon.Text="nz"
	Else
		mFlight.fVon=edtVon.Text
		edtVon.Text=mFlight.fVon
	End If
		
	'Nach
	Dim a As Int
	a=edtNach.Text.Length
	If a=0 Then
		mFlight.fNach="nz"
		edtNach.Text="nz"
	Else
		mFlight.fNach=edtNach.Text
		edtNach.Text=mFlight.fNach
	End If
	
	'Strecke
	Dim a As Int
	a=edtStrecke.Text.Length
	If a=0 Then
		mFlight.fStrecke=0
		edtStrecke.Text=0
	Else
		mFlight.fStrecke=edtStrecke.Text
		edtStrecke.Text=mFlight.fStrecke
	End If
	mFlight.fStrecke=edtStrecke.Text
	
	
	'Bemerkung
	Dim a As Int
	a=edtBemerkung.Text.Length
	If a=0 Then
		mFlight.fBemerkung="nz"
		edtBemerkung.Text="nz"
	Else
		mFlight.fBemerkung=edtBemerkung.Text
		edtBemerkung.Text=mFlight.fBemerkung
	End If

	'Ende	
	If myBool=False Then
		sb=sb.Append(CRLF)
		sb=sb.Append("Bitte korrigieren!").Append(CRLF)
	End If
	Return myBool
	
End Sub

Sub evClick_click
	Dim myBool As Boolean
	myBool=	Validate
	
	Dim ListOfMaps As List
	ListOfMaps.Initialize
	Dim m As Map
	m.Initialize
	m.Put("Datum", mFlight.fDatum)						'Datum (Integer)
	Log (DateTime.Date(mFlight.fDatum))
	m.Put("Pilot", mFlight.fPilot)						'Pilot (Text)
	m.Put("Begleiter", mFlight.fBegleiter)				'Begleiter (Text)
	m.Put("Kennzeichen", mFlight.fKennzeichen)			'Kennzeichen (Text)
	m.Put("Flugzeug", mFlight.fFlugzeug)				'Flugzeug (Text)
	m.Put("FlugzeugID", mFlight.fFlugzeugID)			'FlugzeugID (Integer)
	m.Put("Starts", mFlight.fStarts)					'Starts (Integer)
	m.Put("Startzeit", mFlight.fStartzeit)				'Startzeit (Integer, Ticks)
	m.Put("Landezeit", mFlight.fLandezeit)				'Landezeit (Integer, Ticks) - keine Validierung notwendig -
	m.Put("Flugzeit", mFlight.fFlugzeit)				'Flugzeit (Integer, Ticks) - keine Validierung notwendig -
	m.Put("Startart", mFlight.fStartart)				'Startart (Text) - Validierung notwendig -
	m.Put("StartartID", mFlight.fStartartID)			'StartartID (Integer) - Validierung notwendig -
	m.Put("Flugtyp", mFlight.fFlugtyp)					'Flugtyp (Text) - Validierung notwendig -
	m.Put("FlugtypID", mFlight.fFlugtypID)				'FlugtypID (Integer) - Validierung notwendig -
	m.Put("PicDual", mFlight.fPicDual)					'PicDual (Integer) -Validierung notwendig -
	m.Put("Von", mFlight.fVon)							'Von (Text) - Validierung notwendig -
	m.Put("Nach", mFlight.fNach)						'Nach (Text) - Validierung notwendig -
	m.Put("Strecke", mFlight.fStrecke)					'Strecke (Integer) - Validierung notwendig -
	m.Put("Bemerkung", mFlight.fBemerkung)				'Bemerkung (Text) - keine Validierung notwendig -
	
	Select Main.cADE
		Case 1	'Neuer Flug
			m.Put("Id", Null)
			ListOfMaps.Add(m)
			If myBool = False Then
				MsgboxAsync(sb,"Warnung!")
			Else
				DBUtils.InsertMaps(Main.SQL1, "Fluege", ListOfMaps)
				Activity.Finish
			End If
		Case 2	'Edit Flug
			m.Put("Id", mFlight.fId)
			If myBool = False Then
				MsgboxAsync(sb,"Warnung!")
			Else
				Dim w As Map
				w.Initialize
				w.put("Id", mFlight.fId)
				DBUtils.UpdateRecord2(Main.SQL1, "Fluege",m,w)
				Activity.Finish
			End If
	End Select
		
End Sub

Sub evDelete_Click
	Msgbox2Async("Flug wirklich löschen?", "Warnung", "Ja", "", "Nein", LoadBitmap(File.DirAssets, "warning.png"),False)
	Wait For Msgbox_result(Result As Int)
	If Result = DialogResponse.Positive Then
		Dim m As Map
		m.Initialize
		m.Put("Id", mFlight.fId)
		DBUtils.DeleteRecord(Main.SQL1, "Fluege", m)
		Activity.Finish
	Else
		Activity.Finish
	End If
	
End Sub



