﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=8.3
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible FROM all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed FROM all modules.

End Sub

public Sub DaysInMonth (myMonth As Int, myYear As Int) As Int
	Dim Days, DaysPerMonth() As Int
	DaysPerMonth = Array As Int (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31)
	
	Days = DaysPerMonth(myMonth)
	If myMonth =1 And (myYear Mod 4 = 0) And Not(myYear Mod 100 = 0) Then
		Days = 29
	End If
	
	Return Days
	
End Sub

Public Sub Ticks2Hours(ti As Long) As String
	
	Dim m , h As Double
	m = ti/1000/60
	h = Floor(m/60)
	m=m-h*60
	Return NumberFormat(h,3,0) & ":" & NumberFormat(m,2,0)
	
End Sub

Public Sub Min2Hours(m As Int) As String
	
	Dim h As Int
	h = Floor(m/60)
	m=m-h*60
	Return NumberFormat(h,3,0) & ":" & NumberFormat(m,2,0)
	
End Sub

Public Sub Min2Ticks(in As Int) As Long
	
	Dim out As Long
	out=in*60*1000
	Return out
	
End Sub


Public Sub Pic2Text(in As Int) As String
	
	Dim out As String
	Select in
		Case 0
			out = "Dual"
		Case 1
			out = "Pic"
	End Select
	Return out
	
End Sub

Public Sub Pic2Int(in As String) As Int
	
	Dim out As Int
	Select in
		Case "PIC"
			out = 1
		Case "Dual"
			out = 0
	End Select
	Return out
	
End Sub

Public Sub AlleStarts() As Int
	
	Dim myDum As Int
	Dim myQuery As String
	Dim cur As Cursor

	myDum=0
	myQuery = "SELECT *, SUM(Starts) as SGes FROM Fluege ORDER by Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = myDum
	else if cur.GetString("SGes")=Null Then 
		myDum = myDum
	Else
		myDum = myDum + cur.GetString("SGes")
	End If
	Return myDum
	
End Sub

Public Sub AlleFlugzeit() As Long
	
	Dim myDum As Long
	Dim myQuery As String
	Dim cur As Cursor

	
	myDum=0
	myQuery = "SELECT *, SUM(Flugzeit) as FGes FROM Fluege ORDER by Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = myDum
	else if cur.GetString("FGes")=Null Then
		myDum = myDum
	Else
		myDum = myDum + cur.GetString("FGes")
	End If
	Return myDum

End Sub

Public Sub AlleWinde() As Int
	
	Dim myDum As Int
	Dim myQuery As String
	Dim cur As Cursor

	myQuery = "SELECT *, SUM(Starts) as SGes FROM Fluege WHERE (StartartID=1) ORDER by Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	else if cur.GetString("SGes")=Null Then
		myDum = 0
	Else
		myDum = cur.GetString("SGes")
	End If
	Return myDum
	
End Sub

Public Sub AlleFSchlepps() As Int
	
	Dim myDum As Int
	Dim myQuery As String
	Dim cur As Cursor

	myQuery = "SELECT *, SUM(Starts) as FGes FROM Fluege WHERE (StartartID=2) ORDER by Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	else if cur.GetString("FGes")=Null Then
		myDum = 0
	Else
		myDum = cur.GetString("FGes")
	End If
	Return myDum
	
End Sub

Public Sub AllePicStarts() As Int
	
	Dim myDum As Int
	Dim myQuery As String
	Dim cur As Cursor

	
	myDum=0
	myQuery = "SELECT *, SUM(Starts) as SGes FROM Fluege WHERE PicDual=1 ORDER by Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = myDum
	else if cur.GetString("SGes")=Null Then 
		myDum = myDum
	Else
		myDum = myDum + cur.GetString("SGes")
	End If
	Return myDum
	
End Sub

Public Sub AllePicFlugzeit() As Long
	
	Dim myDum As Long
	Dim myQuery As String
	Dim cur As Cursor

	
	myDum=0
	myQuery = "SELECT *, SUM(Flugzeit) as FGes FROM Fluege WHERE PicDual=1 ORDER by Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = myDum
	else if cur.GetString("FGes")=Null Then
		myDum = myDum
	Else
		myDum = myDum + cur.GetString("FGes")
	End If
	Return myDum
	
End Sub

Public Sub AllePicWinde() As Int
	
	Dim myDum As Int
	Dim myQuery As String
	Dim cur As Cursor

	myQuery = "SELECT *, SUM(Starts) as SGes FROM Fluege WHERE (StartartID=1) AND (PicDual=1) ORDER by Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	else if cur.GetString("SGes")=Null Then
		myDum = 0
	Else
		myDum = cur.GetString("SGes")
	End If
	Return myDum
	
End Sub

Public Sub AllePicFSchlepps() As Int
	
	Dim myDum As Int
	Dim myQuery As String
	Dim cur As Cursor

	myQuery = "SELECT *, SUM(Starts) as FGes FROM Fluege WHERE (StartartID=2) AND (PicDual=1) ORDER by Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	else if cur.GetString("FGes")=Null Then
		myDum = 0
	Else
		myDum = cur.GetString("FGes")
	End If
	Return myDum
	
End Sub

Public Sub AlleDualStarts() As Int
	
	Dim myDum As Int
	Dim myQuery As String
	Dim cur As Cursor

	
	myDum=0
	myQuery = "SELECT *, SUM(Starts) as SGes FROM Fluege WHERE PicDual=0 ORDER by Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = myDum
	else if cur.GetString("SGes")=Null Then 
		myDum = myDum
	Else
		myDum = myDum + cur.GetString("SGes")
	End If
	Return myDum
	
End Sub

Public Sub AlleDualFlugzeit() As Long
	
	Dim myDum As Long
	Dim myQuery As String
	Dim cur As Cursor

	
	myDum=0
	myQuery = "SELECT *, SUM(Flugzeit) as FGes FROM Fluege WHERE PicDual=0 ORDER by Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = myDum
	else if cur.GetString("FGes")=Null Then
		myDum = myDum
	Else
		myDum = myDum + cur.GetString("FGes")
	End If
	Return myDum
	
End Sub

Public Sub AlleDualWinde() As Int
	
	Dim myDum As Int
	Dim myQuery As String
	Dim cur As Cursor

	myQuery = "SELECT *, SUM(Starts) as SGes FROM Fluege WHERE (StartartID=1) AND (PicDual=0) ORDER by Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	else if cur.GetString("SGes")=Null Then
		myDum = 0
	Else
		myDum = cur.GetString("SGes")
	End If
	Return myDum
	
End Sub

Public Sub AlleDualFSchlepps() As Int
	
	Dim myDum As Int
	Dim myQuery As String
	Dim cur As Cursor

	myQuery = "SELECT *, SUM(Starts) as FGes FROM Fluege WHERE (StartartID=2) AND (PicDual=0) ORDER by Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	else if cur.GetString("FGes")=Null Then
		myDum = 0
	Else
		myDum = cur.GetString("FGes")
	End If
	Return myDum
	
End Sub



Public Sub LetzterSchulstart() As Long
	
	Dim myDum As Long
	Dim myQuery As String
	Dim cur As Cursor

	DateTime.DateFormat="dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	myQuery = "SELECT * FROM Fluege WHERE (FlugtypID=1) ORDER by Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	else if cur.GetString("Datum")=Null Then 
		myDum = 0
	Else
		myDum = cur.GetString("Datum")
	End If
	Return myDum
	
End Sub

Public Sub Ablauf5Winde() As Long
	
	Dim myDum As Long
	Dim myQuery As String
	Dim cur As Cursor

	DateTime.DateFormat="dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	myQuery = "Select *, (SELECT Sum(Starts) FROM Fluege AS fb1 "
	myQuery = myQuery & "WHERE (fb1.Startzeit >= fb2.Startzeit) AND (fb1.PicDual=1) AND (fb1.StartartID=1)) AS Sges "
	myQuery = myQuery & "FROM Fluege AS fb2 WHERE (fb2.PicDual=1) AND (fb2.StartartID=1) AND Sges >= 5 "
	myQuery = myQuery & "ORDER BY fb2.Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	else if cur.GetString("Datum")=Null Then 
		myDum = 0
	Else
		myDum = cur.GetString("Datum")
	End If
	myDum=DateTime.Add(myDum,0,24,-1)
	Return myDum
	
End Sub

Public Sub Ablauf5FSchlepps() As Long
	
	Dim myDum As Long
	Dim myQuery As String
	Dim cur As Cursor

	DateTime.DateFormat="dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	myQuery = "Select *, (SELECT Sum(Starts) FROM Fluege AS fb1 "
	myQuery = myQuery & "WHERE (fb1.Startzeit >= fb2.Startzeit) AND (fb1.PicDual=1) AND (fb1.StartartID=2)) AS Sges "
	myQuery = myQuery & "FROM Fluege AS fb2 WHERE (fb2.PicDual=1) AND (fb2.StartartID=2) AND Sges >= 5 "
	myQuery = myQuery & "ORDER BY fb2.Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	else if cur.GetString("Datum")=Null Then 
		myDum = 0
	Else
		myDum = cur.GetString("Datum")
	End If
	myDum=DateTime.Add(myDum,0,24,-1)
	Return myDum
	
End Sub

Public Sub AblaufTauglichkeit() As Long
	
	Dim myDum As Long
	Dim myQuery As String
	Dim cur As Cursor

	myQuery = "SELECT * FROM PersDaten"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	else if cur.GetString("AblaufTauglich")=Null Then
		myDum = 0
	Else
		myDum=cur.GetString("AblaufTauglich")
	End If
	Return myDum
	
End Sub

Public Sub AblaufFluglehrer() As Long
	
	Dim myDum As Long
	Dim myQuery As String
	Dim cur As Cursor

	myQuery = "SELECT * FROM PersDaten"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	else if cur.GetString("AblaufFluglehrer")=Null Then
		myDum = 0
	Else
		myDum=cur.GetString("AblaufFluglehrer")
	End If
	Return myDum
	
End Sub

Public Sub AblaufKompetenz() As Long
	
	Dim myDum As Long
	Dim myQuery As String
	Dim cur As Cursor

	myQuery = "SELECT * FROM PersDaten"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	else if cur.GetString("AblaufKomp")=Null Then 
		myDum = 0
	Else
		myDum=cur.GetString("AblaufKomp")
	End If
	Return myDum
	
End Sub

Public Sub AblaufZuep() As Long
	
	Dim myDum As Long
	Dim myQuery As String
	Dim cur As Cursor

	myQuery = "SELECT * FROM PersDaten"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	else if cur.GetString("AblaufZueP")=Null Then
		myDum = 0
	Else
		myDum=cur.GetString("AblaufZueP")
	End If
	Return myDum
	
End Sub

Public Sub AblaufUebungsleiter() As Long
	
	Dim myDum As Long
	Dim myQuery As String
	Dim cur As Cursor

	myQuery = "SELECT * FROM PersDaten"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	else if cur.GetString("AblaufUebungsl")=Null Then
		myDum = 0
	Else
		myDum=cur.GetString("AblaufUebungsl")
	End If
	Return myDum
	
End Sub

Public Sub AblaufTrainer() As Long
	
	Dim myDum As Long
	Dim myQuery As String
	Dim cur As Cursor

	myQuery = "SELECT * FROM PersDaten"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	else if cur.GetString("AblaufTrainer")=Null Then
		myDum = 0
	Else
		myDum=cur.GetString("AblaufTrainer")
	End If
	Return myDum
	
End Sub

Public Sub AblaufDeutsch() As Long
	
	Dim myDum As Long
	Dim myQuery As String
	Dim cur As Cursor

	myQuery = "SELECT * FROM PersDaten"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	else if cur.GetString("AblaufDeutsch")=Null Then 
		myDum = 0
	Else
		myDum=cur.GetString("AblaufDeutsch")
	End If
	Return myDum
	
End Sub

Public Sub AblaufEnglisch() As Long
	
	Dim myDum As Long
	Dim myQuery As String
	Dim cur As Cursor

	myQuery = "SELECT * FROM PersDaten"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	else if cur.GetString("AblaufEnglisch")=Null Then
		myDum = 0
	Else
		myDum=cur.GetString("AblaufEnglisch")
	End If
	Return myDum
	
End Sub

Public Sub LevelDeutsch() As Int
	
	Dim myLevel As Int
	Dim myQuery As String
	Dim cur As Cursor

	myQuery = "SELECT * FROM PersDaten"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myLevel = 99
	else if cur.GetString("LevelDeutsch")=Null Then
		myLevel = 99
	Else
		myLevel=cur.GetString("LevelDeutsch")
	End If
	Return myLevel
	
End Sub

Public Sub LevelEnglisch() As Int
	
	Dim myLevel As Int
	Dim myQuery As String
	Dim cur As Cursor

	myQuery = "SELECT * FROM PersDaten"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myLevel = 99
	else if cur.GetString("LevelEnglisch")=Null Then
		myLevel = 99
	Else
		myLevel=cur.GetString("LevelEnglisch")
	End If
	Return myLevel
	
End Sub

Public Sub Ablauf2FI() As Long
	
	DateTime.DateFormat="dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	Dim myDum As Long
	Dim myQuery As String
	Dim cur As Cursor

	myQuery = "Select *, (Select Sum(Starts) FROM Fluege As fb1 "
	myQuery = myQuery & "WHERE (fb1.Startzeit >= fb2.Startzeit) And (fb1.FlugtypID=8)) AS Sges "
	myQuery = myQuery & "FROM Fluege As fb2 WHERE (fb2.FlugtypID=8) And Sges >= 2 "
	myQuery = myQuery & "ORDER BY fb2.Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	Else if cur.GetString("Datum") = Null Then
		myDum = 0
	Else
		myDum = cur.GetString("Datum")
		myDum=DateTime.Add(myDum,0,24,-1)
	End If
	Return myDum
	
End Sub

Public Sub Ablauf15Starts() As Long
	
	DateTime.DateFormat="dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	Dim myDum As Long
	Dim myQuery As String
	Dim cur As Cursor

	myQuery = "Select *, (Select Sum(Starts) FROM Fluege As fb1 "
	myQuery = myQuery & "WHERE (fb1.Startzeit >= fb2.Startzeit) And (fb1.PicDual=1)) AS Sges "
	myQuery = myQuery & "FROM Fluege As fb2 WHERE (fb2.PicDual=1) And Sges >= 15 "
	myQuery = myQuery & "ORDER BY fb2.Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	Else if cur.GetString("Datum") = Null Then
		myDum = 0
	Else
		myDum = cur.GetString("Datum")
		myDum=DateTime.Add(myDum,0,24,-1)
	End If
	Return myDum
	
End Sub

Public Sub Ablauf5hPic() As Long
	
	DateTime.DateFormat="dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	Dim myDum As Long
	Dim myQuery As String
	Dim cur As Cursor

	myQuery = "Select *, (Select Sum(Flugzeit) FROM Fluege As fb1 "
	myQuery = myQuery & "WHERE (fb1.Startzeit >= fb2.Startzeit) And (fb1.PicDual=1)) AS Zges "
	myQuery = myQuery & "FROM Fluege As fb2 WHERE (fb2.PicDual=1) And Zges >= 18000000 "
	myQuery = myQuery & "ORDER BY fb2.Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	Else if cur.GetString("Datum") = Null Then
		myDum = 0
	Else
		myDum = cur.GetString("Datum")
		myDum=DateTime.Add(myDum,0,24,-1)
	End If
	Return myDum
	
End Sub

Public Sub AnzahlWinde24Mo() As Int
	
	Dim myDum As Int
	Dim myQuery As String
	Dim cur As Cursor
	Dim myDate24 As Long
	
	DateTime.DateFormat="dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	myDate24=DateTime.Add(DateTime.Now, 0, -24, 1)
	Log ("Heute - 24 Mo: " & DateTime.Date(myDate24))
	myQuery = "Select *, Sum(Starts) AS Sges FROM Fluege "
	myQuery = myQuery & "WHERE (StartartID=1) AND (Datum >= '" & myDate24 & "') AND (PicDual=1) ORDER BY Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	Else if cur.GetString("Sges") = Null Then
		myDum = 0
	Else
		myDum = cur.GetString("Sges")
	End If
	Return myDum
	
End Sub

Public Sub AnzahlFSchlepps24Mo() As Int
	
	Dim myDum As Int
	Dim myQuery As String
	Dim cur As Cursor
	Dim myDate24 As Long

	DateTime.DateFormat="dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	myDate24=DateTime.Add(DateTime.Now, 0, -24, 1)
	myQuery = "Select *, Sum(Starts) AS Sges FROM Fluege "
	myQuery = myQuery & "WHERE (StartartID=2) AND (Datum >= '" & myDate24 & "') AND (PicDual=1) ORDER BY Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	Else if cur.GetString("Sges") = Null Then
		myDum = 0
	Else
		myDum = cur.GetString("Sges")
	End If
	Return myDum
	
End Sub

Public Sub AnzahlPicStarts24Mo() As Int
	
	Dim myDum As Int
	Dim myQuery As String
	Dim cur As Cursor
	Dim myDate24 As Long

	DateTime.DateFormat="dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	myDate24=DateTime.Add(DateTime.Now, 0, -24, 1)
	Log ("Heute - 24 Mo: " & myDate24)
	myQuery = "Select *, Sum(Starts) AS Sges FROM Fluege "
	myQuery = myQuery & "WHERE (Datum >= '" & myDate24 & "') AND (PicDual=1) ORDER BY Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	Else if cur.GetString("Sges") = Null Then
		myDum = 0
	Else
		myDum = cur.GetString("Sges")
	End If
	Return myDum
	
End Sub

Public Sub AnzahlFlugzeit24Mo() As Long
	
	Dim myDum As Long
	Dim myQuery As String
	Dim cur As Cursor
	Dim myDate24 As Long

	DateTime.DateFormat="dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	myDate24=DateTime.Add(DateTime.Now, 0, -24, 1)
	Log ("Heute - 24 Mo: " & myDate24)
	myQuery = "Select *, Sum(Flugzeit) AS Sges FROM Fluege "
	myQuery = myQuery & "WHERE (Datum >= '" & myDate24 & "') ORDER BY Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	Else if cur.GetString("Sges") = Null Then
		myDum = 0
	Else
		myDum = cur.GetString("Sges")
	End If
	Return myDum
	
End Sub

Public Sub AnzahlFlugzeitPic24Mo() As Long
	
	Dim myDum As Long
	Dim myQuery As String
	Dim cur As Cursor
	Dim myDate24 As Long

	DateTime.DateFormat="dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	myDate24=DateTime.Add(DateTime.Now, 0, -24, 1)
	Log ("Heute - 24 Mo: " & myDate24)
	myQuery = "Select *, Sum(Flugzeit) AS Sges FROM Fluege "
	myQuery = myQuery & "WHERE (Datum >= '" & myDate24 & "') AND (PicDual=1) ORDER BY Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	Else if cur.GetString("Sges") = Null Then
		myDum = 0
	Else
		myDum = cur.GetString("Sges")
	End If
	Return myDum
	
End Sub

Public Sub AnzahlFIStarts24Mo() As Long
	
	Dim myDum As Long
	Dim myQuery As String
	Dim cur As Cursor
	Dim myDate24 As Long

	DateTime.DateFormat="dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	myDate24=DateTime.Add(DateTime.Now, 0, -24, 1)
	myQuery = "Select *, Sum(Starts) AS Sges FROM Fluege "
	myQuery = myQuery & "WHERE (Datum >= '" & myDate24 & "') AND (FlugtypID=8) ORDER BY Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	Else if cur.GetString("Sges") = Null Then
		myDum = 0
	Else
		myDum = cur.GetString("Sges")
	End If
	Return myDum
	
End Sub

Public Sub AnzahlStarts90Tage() As Int
	
	Dim myDum As Int
	Dim myQuery As String
	Dim cur As Cursor
	Dim myDate90 As Long

	DateTime.DateFormat="dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	myDate90=DateTime.Add(DateTime.Now, 0, 0, -90+1)
	myQuery = "Select *, Sum(Starts) AS Sges FROM Fluege "
	myQuery = myQuery & "WHERE (Datum >= '" & myDate90 & "') AND (PicDual=1) ORDER BY Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
		myDum = 0
	Else if cur.GetString("Sges") = Null Then
		myDum = 0
	Else
		myDum = cur.GetString("Sges")
	End If
	Return myDum
	
End Sub

Public Sub AlleVerlFIStarts() As Int
	
	Dim myDum As Int
	Dim mylaufFI As Long
	Dim myQuery As String
	Dim cur As Cursor

	myQuery = "SELECT * FROM PersDaten"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	mylaufFI=cur.GetString("AblaufFluglehrer")
	mylaufFI=DateTime.Add(mylaufFI, -3, 0, 1)
	myQuery = "Select *, Sum(Starts) AS Sges FROM Fluege "
	myQuery = myQuery & "WHERE (Datum >= '" & mylaufFI & "') AND "
	myQuery = myQuery & "((FlugtypID=1) OR (FlugtypID=3) OR (FlugtypID=4)) "
	myQuery = myQuery & "ORDER BY Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
			myDum = 0
	Else if cur.GetString("Sges") = Null Then
			myDum = 0
	Else
			myDum=cur.GetString("Sges")
	End If
	Return myDum
	
End Sub

Public Sub AlleVerlFIFlugzeit() As Long
	
	Dim myDum As Long
	Dim mylaufFI As Long
	Dim myQuery As String
	Dim cur As Cursor

	myQuery = "SELECT * FROM PersDaten"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	mylaufFI=cur.GetString("AblaufFluglehrer")
	mylaufFI=DateTime.Add(mylaufFI, -3, 0, 1)
	myQuery = "Select *, Sum(Flugzeit) AS Fges FROM Fluege "
	myQuery = myQuery & "WHERE (Datum >= '" & mylaufFI & "') AND "
	myQuery = myQuery & "((FlugtypID=1) OR (FlugtypID=3) OR (FlugtypID=4)) "
	myQuery = myQuery & "ORDER BY Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
			myDum = 0
	Else if cur.GetString("Fges") = Null Then
			myDum = 0
	Else
			myDum=cur.GetString("Fges")
	End If
	Return myDum
	
End Sub

Public Sub AlleVerlFIWinde() As Int
	
	Dim myDum As Int
	Dim mylaufFI As Long
	Dim myQuery As String
	Dim cur As Cursor

	myQuery = "SELECT * FROM PersDaten"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	mylaufFI=cur.GetString("AblaufFluglehrer")
	mylaufFI=DateTime.Add(mylaufFI, -3, 0, 1)
	myQuery = "Select *, Sum(Starts) AS Sges FROM Fluege "
	myQuery = myQuery & "WHERE (Datum >= '" & mylaufFI & "') AND (StartartID=1) AND "
	myQuery = myQuery & "((FlugtypID=1) OR (FlugtypID=3) OR (FlugtypID=4)) "
	myQuery = myQuery & "ORDER BY Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
			myDum = 0
	Else if cur.GetString("Sges") = Null Then
			myDum = 0
	Else
			myDum=cur.GetString("Sges")
	End If
	Return myDum
	
End Sub

Public Sub AlleVerlFIFSchlepps() As Int
	
	Dim myDum As Int
	Dim mylaufFI As Long
	Dim myQuery As String
	Dim cur As Cursor

	myQuery = "SELECT * FROM PersDaten"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	mylaufFI=cur.GetString("AblaufFluglehrer")
	mylaufFI=DateTime.Add(mylaufFI, -3, 0, 1)
	myQuery = "Select *, Sum(Starts) AS Sges FROM Fluege "
	myQuery = myQuery & "WHERE (Datum >= '" & mylaufFI & "') AND (StartartID=2) AND "
	myQuery = myQuery & "((FlugtypID=1) OR (FlugtypID=3) OR (FlugtypID=4)) "
	myQuery = myQuery & "ORDER BY Startzeit DESC"
	cur = Main.SQL1.ExecQuery(myQuery)
	cur.Position=0
	If cur.RowCount=0 Then
			myDum = 0
	Else if cur.GetString("Sges") = Null Then
			myDum = 0
	Else
			myDum=cur.GetString("Sges")
	End If
	Return myDum
	
End Sub


Public Sub myAblauf() As List
	
	Dim myListOfMaps As List
	myListOfMaps.Initialize
	Dim myMap1 As Map
	myMap1.Initialize
	Dim myMap2 As Map
	myMap2.Initialize
	
	Dim myAnz As Int
	myAnz=AlleStarts
	myMap1.Put("AlleStarts", myAnz)
	myMap2.Put("SetColor0", 2)
	
	Dim myAnz As Int
	myAnz=AllePicStarts
	myMap1.Put("AllePicStarts", myAnz)
	myMap2.Put("SetColor1", 2)
	
	Dim mylong As Long
	mylong = AlleFlugzeit
	myMap1.Put("AlleFlugzeit", mylong)
	myMap2.Put("SetColor2", 2)
	
	Dim mylong As Long
	mylong = AllePicFlugzeit
	myMap1.Put("AllePicFlugzeit", mylong)
	myMap2.Put("SetColor3", 2)
	
	Dim myAnz As Int
	myAnz=AlleWinde
	myMap1.Put("AlleWinde", myAnz)
	myMap2.Put("SetColor4", 2)
	
	Dim myAnz As Int
	myAnz=AlleFSchlepps
	myMap1.Put("AlleFSchlepps", myAnz)
	myMap2.Put("SetColor5", 2)
	
	Dim myDate As Long
	myDate=LetzterSchulstart
	myMap1.Put("LetzterSchulstart", myDate)
	myMap2.Put("SetColor6", 2)
	
	Dim i As Int
	Dim myDate As Long
	myDate=Ablauf5Winde
	If DateTime.Now > myDate Then
		i = 1
	Else
		i = 0
	End If
	myMap1.Put("Ablauf5Winde", myDate)
	myMap2.Put("SetColor7", i)
	
	Dim i As Int
	Dim myDate As Long
	myDate=Ablauf5FSchlepps
	If DateTime.Now > myDate Then
		i = 1
	Else
		i = 0
	End If
	myMap1.Put("Ablauf5FSchlepps", myDate)
	myMap2.Put("SetColor8", i)
	
	Dim i As Int
	Dim myDate As Long
	myDate=AblaufTauglichkeit
	If DateTime.Now > myDate Then
		i = 1
	Else
		i = 0
	End If
	myMap1.Put("AblaufTauglichkeit", myDate)
	myMap2.Put("SetColor9", i)
	
	Dim i As Int
	Dim myDate As Long
	myDate=AblaufFluglehrer
	If DateTime.Now > myDate Then
		i = 1
	Else
		i = 0
	End If
	myMap1.Put("AblaufFluglehrer", myDate)
	myMap2.Put("SetColor10", i)
	
	Dim i As Int
	Dim myDate As Long
	myDate=AblaufKompetenz
	If DateTime.Now > myDate Then
		i = 1
	Else
		i = 0
	End If
	myMap1.Put("AblaufKompetenz", myDate)
	myMap2.Put("SetColor11", i)
	
	Dim i As Int
	Dim myDate As Long
	myDate=AblaufZuep
	If DateTime.Now > myDate Then
		i = 1
	Else
		i = 0
	End If
	myMap1.Put("AblaufZuep", myDate)
	myMap2.Put("SetColor12", i)
	
	Dim i As Int
	Dim myDate As Long
	myDate=AblaufUebungsleiter
	If DateTime.Now > myDate Then
		i = 1
	Else
		i = 0
	End If
	myMap1.Put("AblaufUebungsleiter", myDate)
	myMap2.Put("SetColor13", i)
	
	Dim i As Int
	Dim myDate As Long
	myDate=AblaufTrainer
	If DateTime.Now > myDate Then
		i = 1
	Else
		i = 0
	End If
	myMap1.Put("AblaufTrainer", myDate)
	myMap2.Put("SetColor14", i)
	
	Dim i As Int
	Dim myDate As Long
	myDate=AblaufDeutsch
	If DateTime.Now > myDate Then
		i = 1
	Else
		i = 0
	End If
	myMap1.Put("AblaufDeutsch", myDate)
	myMap2.Put("SetColor15", i)
	
	Dim i As Int
	Dim myDate As Long
	myDate=AblaufEnglisch
	If DateTime.Now > myDate Then
		i = 1
	Else
		i = 0
	End If
	myMap1.Put("AblaufEnglisch", myDate)
	myMap2.Put("SetColor16", i)
	
	Dim myLevel As Int
	myLevel=LevelDeutsch
	myMap1.Put("LevelDeutsch", myLevel)
	myMap2.Put("SetColor17", 2)
	
	Dim myLevel As Int
	myLevel=LevelEnglisch
	myMap1.Put("LevelEnglisch", myLevel)
	myMap2.Put("SetColor18", 2)
	
	Dim i As Int
	Dim myDate As Long
	myDate=Ablauf2FI
	If DateTime.Now > myDate Then
		i = 1
	Else
		i = 0
	End If
	myMap1.Put("Ablauf2FI", myDate)
	myMap2.Put("SetColor19", i)
	
	Dim i As Int
	Dim myDate As Long
	myDate=Ablauf15Starts
	If DateTime.Now > myDate Then
		i = 1
	Else
		i = 0
	End If
	myMap1.Put("Ablauf15Starts", myDate)
	myMap2.Put("SetColor20", i)
	
	Dim i As Int
	Dim myDate As Long
	myDate=Ablauf5hPic
	If DateTime.Now > myDate Then
		i = 1
	Else
		i = 0
	End If
	myMap1.Put("Ablauf5hPic", myDate)
	myMap2.Put("SetColor21", i)
	
	Dim myAnz As Int
	myAnz=AnzahlWinde24Mo
	myMap1.Put("AnzahlWinde24Mo", myAnz)
	myMap2.Put("SetColor22", 2)
	
	Dim myAnz As Int
	myAnz=AnzahlFSchlepps24Mo
	myMap1.Put("AnzahlFSchlepps24Mo", myAnz)
	myMap2.Put("SetColor23", 2)
	
	Dim myAnz As Int
	myAnz=AnzahlPicStarts24Mo
	myMap1.Put("AnzahlPicStarts24Mo", myAnz)
	myMap2.Put("SetColor24", 2)
	
	Dim mylong As Long
	mylong = AnzahlFlugzeit24Mo
	myMap1.Put("AnzahlFlugzeit24Mo", mylong)
	myMap2.Put("SetColor25", 2)
	
	Dim mylong As Long
	mylong = AnzahlFlugzeitPic24Mo
	myMap1.Put("AnzahlFlugzeitPic24Mo", mylong)
	myMap2.Put("SetColor26", 2)
	
	Dim i As Int
	Dim myAnz As Int
	myAnz=AnzahlStarts90Tage
	If myAnz < 3 Then
		i = 1
	Else
		i = 0
	End If
	myMap1.Put("AnzahlStarts90Tage", myAnz)
	myMap2.Put("SetColor27", i)
	
	Dim myAnz As Int
	myAnz=AnzahlFIStarts24Mo
	myMap1.Put("AnzahlFIStarts24Mo", myAnz)
	myMap2.Put("SetColor29", 2)
	
	Dim myAnz As Int
	myAnz=AllePicWinde
	myMap1.Put("AllePicWinde", myAnz)
	myMap2.Put("SetColor30", 2)
	
	Dim myAnz As Int
	myAnz=AllePicFSchlepps
	myMap1.Put("AllePicFSchlepps", myAnz)
	myMap2.Put("SetColor31", 2)
	
	Dim myAnz As Int
	myAnz=AlleDualStarts
	myMap1.Put("AlleDualStarts", myAnz)
	myMap2.Put("SetColor32", 2)
	
	Dim mylong As Long
	mylong=AlleDualFlugzeit
	myMap1.Put("AlleDualFlugzeit", mylong)
	myMap2.Put("SetColor33", 2)
	
	Dim myAnz As Int
	myAnz=AlleDualWinde
	myMap1.Put("AlleDualWinde", myAnz)
	myMap2.Put("SetColor34", 2)

	Dim myAnz As Int
	myAnz=AlleDualFSchlepps
	myMap1.Put("AlleDualFSchlepps", myAnz)
	myMap2.Put("SetColor35", 2)
	
	Dim myAnz As Int
	myAnz=AlleVerlFIStarts
	myMap1.Put("AlleVerlFIStarts", myAnz)
	myMap2.Put("SetColor36", 2)
	
	Dim mylong As Long
	mylong=AlleVerlFIFlugzeit
	myMap1.Put("AlleVerlFIFlugzeit", mylong)
	myMap2.Put("SetColor37", 2)

	Dim myAnz As Int
	myAnz=AlleVerlFIWinde
	myMap1.Put("AlleVerlFIWinde", myAnz)
	myMap2.Put("SetColor38", 2)

	Dim myAnz As Int
	myAnz=AlleVerlFIFSchlepps
	myMap1.Put("AlleVerlFIFSchlepps", myAnz)
	myMap2.Put("SetColor39", 2)
	
	myListOfMaps.Add(myMap1)
	myListOfMaps.Add(myMap2)
	
	Return myListOfMaps
	
End Sub

Sub ReadPersDaten
	
	Dim Query As String
	Dim cur As Cursor
	
	Query="SELECT * FROM PersDaten"
	cur = Main.SQL1.ExecQuery(Query)
	cur.Position=0
	Main.cPersDaten.Initialize
	Main.cPersDaten.Id=cur.GetString("Id")
	Main.cPersDaten.name=cur.GetString("Name")
	Main.cPersDaten.Vorname=cur.GetString("Vorname")
	Main.cPersDaten.Geburtsdatum=cur.GetString("Geburtsdatum")
	Main.cPersDaten.Strasse=cur.GetString("Strasse")
	Main.cPersDaten.Postleitzahl=cur.GetString("Postleitzahl")
	Main.cPersDaten.Ort=cur.GetString("Ort")
	Main.cPersDaten.Land=cur.GetString("Land")
	Main.cPersDaten.LizenzNr=cur.GetString("LizenzNr")
	Main.cPersDaten.LevelDeutsch=cur.GetString("LevelDeutsch")
	Main.cPersDaten.LevelEnglisch=cur.GetString("LevelEnglisch")
	Main.cPersDaten.AblaufDeutsch=cur.GetString("AblaufDeutsch")
	Main.cPersDaten.AblaufEnglisch=cur.GetString("AblaufEnglisch")
	Main.cPersDaten.AblaufTauglich=cur.GetString("AblaufTauglich")
	Main.cPersDaten.AblaufZuep=cur.GetString("AblaufZueP")
	Main.cPersDaten.AblaufTrainer=cur.GetString("AblaufTrainer")
	Main.cPersDaten.AblaufUebungsleiter=cur.GetString("AblaufUebungsl")
	Main.cPersDaten.FluglehrerJN=cur.GetString("FluglehrerJN")
	Main.cPersDaten.FluglehrerNr=cur.GetString("FluglehrerNr")
	Main.cPersDaten.AblaufFluglehrer=cur.GetString("AblaufFluglehrer")
	Main.cPersDaten.AblaufKomp=cur.GetString("AblaufKomp")
	
End Sub

Sub ValStringLen(mText As String) As Boolean
	
	Dim ret As Boolean =True
	If mText.Length=0 Then
		ret=False
	End If
	Return ret
End Sub