﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.28
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private edtFlugtyp As EditText
	Private edtBemerkung As EditText
	Private edtFlugtypNr As EditText
	Private spiPicDual As Spinner
		
	Private mFlugtyp As Sdata2
	Dim sb As StringBuilder
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	
	Activity.LoadLayout("LayoutFlugtypInput")	
	spiPicDual.Add("PIC")
	spiPicDual.Add("Dual")
	mFlugtyp.Initialize
	
	Select Main.cADE
		Case 1
			Activity.Title="Flugtyp Hinzufügen"
			Activity.TitleColor=Colors.Blue
			Activity.AddMenuItem3("Add", "evClick", LoadBitmap(File.DirAssets, "Add.png"),True)
			InitAdd
		Case 2
			Activity.Title="Flugzeug Ändern/Löschen"
			Activity.TitleColor=Colors.Blue
			Activity.AddMenuItem3("Delete", "evDelete", LoadBitmap(File.DirAssets, "Delete.png"),True)
			Activity.AddMenuItem3("Edit", "evClick", LoadBitmap(File.DirAssets, "Edit.png"),True)
			InitEditDelete
	End Select
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub InitAdd
	edtFlugtyp.Text="Flugtyp"
	edtBemerkung.Text="nz"
	edtFlugtypNr.Text="0"
	spiPicDual.SelectedIndex=0
	mFlugtyp.MyPicDual=spiPicDual.GetItem(spiPicDual.SelectedIndex)
End Sub

Sub InitEditDelete
	mFlugtyp.MyId=Main.cFlugtyp.MyId
	
	edtFlugtyp.Text=Main.cFlugtyp.MyFlugtyp
	mFlugtyp.MyFlugtyp=Main.cFlugtyp.MyFlugtyp
	
	edtFlugtypNr.Text=Main.cFlugtyp.MyNr
	mFlugtyp.MyNr=Main.cFlugtyp.MyNr
	
	edtBemerkung.Text=Main.cFlugtyp.MyBemerkung
	mFlugtyp.MyBemerkung=Main.cFlugtyp.MyBemerkung

	spiPicDual.SelectedIndex=spiPicDual.IndexOf(Main.cFlugtyp.MyPicDual)
	mFlugtyp.MyPicDual=spiPicDual.GetItem(spiPicDual.SelectedIndex)
	
	mFlugtyp.MyColor=Main.cFlugtyp.MyColor
	
End Sub

Sub evClick_click
	Dim ListOfMaps As List
	ListOfMaps.Initialize
	Dim m As Map
	m.Initialize
	m.Put("Nr", edtFlugtypNr.Text)
	m.Put("Flugtyp", edtFlugtyp.Text)
	m.Put("PicDual", mFlugtyp.MyPicDual)
	m.Put("Bemerkung", edtBemerkung.Text)
	
	Dim myBool As Boolean
	myBool=Validate
	Select Main.cADE
		Case 1	'Neues Flugzeug
			m.Put("Id", Null)
			ListOfMaps.Add(m)
			If myBool = False Then
				MsgboxAsync(sb,"Warnung!")
			Else
				DBUtils.InsertMaps(Main.SQL1, "Flugtyp", ListOfMaps)
				Activity.Finish
			End If
		Case 2	'Edit Flugzeug
			m.Put("Id", mFlugtyp.MyId)
			If myBool = False Then
				MsgboxAsync(sb,"Warnung!")
			Else
				Dim w As Map
				w.Initialize
				w.put("Id", mFlugtyp.MyId)
				DBUtils.UpdateRecord2(Main.SQL1, "Flugtyp",m,w)
				Activity.Finish
			End If
	End Select
End Sub

Sub evDelete_Click
	Msgbox2Async("Flugtyp wirklich löschen?", "Warnung", "Ja", "", "Nein", LoadBitmap(File.DirAssets, "warning.png"),False)
	Wait For Msgbox_result(Result As Int)
	If Result = DialogResponse.Positive Then
		Dim m As Map
		m.Initialize
		m.Put("Id", mFlugtyp.MyId)
		DBUtils.DeleteRecord(Main.SQL1, "Flugtyp", m)
		Activity.Finish
	Else
		Activity.Finish
	End If
End Sub

Sub Validate () As Boolean
	Dim myBool As Boolean
	myBool = True
	sb.Initialize
	
	If edtFlugtyp.Text.Length=0 Then
		edtFlugtyp.Text="Flugtyp"
		myBool=False
		sb.Append("Flugtyp ist Pflichtfeld").Append(CRLF)
	End If
	If edtBemerkung.Text.Length=0 Then
		edtBemerkung.Text="nz"
		myBool=False
		sb.Append("Bemerkung ist Pflichtfeld").Append(CRLF)
	End If
	If edtFlugtypNr.Text.Length=0 Then
		edtFlugtypNr.Text="0"
		myBool=False
		sb.Append("Nr ist Pflichtfeld").Append(CRLF)
	End If
		
	'Ende
	If myBool=False Then
		sb=sb.Append(CRLF)
		sb=sb.Append("Bitte korrigieren!").Append(CRLF)
	End If
	Return myBool
End Sub

Sub spiPicDual_ItemClick (Position As Int, Value As Object)
	Dim s As String
	s= Value
	mFlugtyp.MyPicDual=s
End Sub