﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.28
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private edtStartart As EditText
	Private edtBemerkung As EditText
	Private edtStartartNr As EditText

	Private mStartart As Sdata
	Dim sb As StringBuilder

End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	
	Activity.LoadLayout("LayoutStartartInput")
	Select Main.cADE
		Case 1
			Activity.Title="Startart Hinzufügen"
			Activity.TitleColor=Colors.Blue
			Activity.AddMenuItem3("Add", "evClick", LoadBitmap(File.DirAssets, "Add.png"),True)
			InitAdd
		Case 2
			Activity.Title="Startart Ändern/Löschen"
			Activity.TitleColor=Colors.Blue
			Activity.AddMenuItem3("Delete", "evDelete", LoadBitmap(File.DirAssets, "Delete.png"),True)
			Activity.AddMenuItem3("Edit", "evClick", LoadBitmap(File.DirAssets, "Edit.png"),True)
			InitEditDelete
	End Select
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub InitAdd
	edtStartart.Text="Startart"
	edtBemerkung.Text="nz"
	edtStartartNr.Text="0"
End Sub

Sub InitEditDelete
	mStartart.MyId=Main.cStartart.MyId
	
	edtStartart.Text=Main.cStartart.MyStartart
	mStartart.MyStartart=Main.cStartart.MyStartart
	
	edtStartartNr.Text=Main.cStartart.MyNr
	mStartart.MyNr=Main.cStartart.MyNr
	
	edtBemerkung.Text=Main.cStartart.MyBemerkung
	mStartart.MyBemerkung=Main.cStartart.MyBemerkung
	
	mStartart.MyColor=Main.cStartart.MyColor
	
End Sub

Sub evClick_click
	Dim ListOfMaps As List
	ListOfMaps.Initialize
	Dim m As Map
	m.Initialize
	m.Put("Nr", edtStartartNr.Text)
	m.Put("Startart", edtStartart.Text)
	m.Put("Bemerkung", edtBemerkung.Text)
	
	Dim myBool As Boolean
	myBool=Validate
	Select Main.cADE
		Case 1	'Neue Startart
			m.Put("Id", Null)
			ListOfMaps.Add(m)
			If myBool = False Then
				MsgboxAsync(sb,"Warnung!")
			Else
				DBUtils.InsertMaps(Main.SQL1, "Startart", ListOfMaps)
				Activity.Finish
			End If
		Case 2	'Edit Startart
			m.Put("Id", mStartart.MyId)
			If myBool = False Then
				MsgboxAsync(sb,"Warnung!")
			Else
				Dim w As Map
				w.Initialize
				w.put("Id", mStartart.MyId)
				DBUtils.UpdateRecord2(Main.SQL1, "Startart",m,w)
				Activity.Finish
			End If
	End Select
End Sub

Sub evDelete_Click
	Msgbox2Async("Startart wirklich löschen?", "Warnung", "Ja", "", "Nein", LoadBitmap(File.DirAssets, "warning.png"),False)
	Wait For Msgbox_result(Result As Int)
	If Result = DialogResponse.Positive Then
		Dim m As Map
		m.Initialize
		m.Put("Id", mStartart.MyId)
		DBUtils.DeleteRecord(Main.SQL1, "Startart", m)
		Activity.Finish
	Else
		Activity.Finish
	End If
End Sub

Sub Validate () As Boolean
	Dim myBool As Boolean
	myBool = True
	sb.Initialize
	
	If edtStartart.Text.Length=0 Then
		edtStartart.Text="Startart"
		myBool=False
		sb.Append("Startart ist Pflichtfeld").Append(CRLF)
	End If
	If edtBemerkung.Text.Length=0 Then
		edtBemerkung.Text="nz"
		myBool=False
		sb.Append("Bemerkung ist Pflichtfeld").Append(CRLF)
	End If
	If edtStartartNr.Text.Length=0 Then
		edtStartartNr.Text="0"
		myBool=False
		sb.Append("Nr ist Pflichtfeld").Append(CRLF)
	End If	
	'Ende
	If myBool=False Then
		sb=sb.Append(CRLF)
		sb=sb.Append("Bitte korrigieren!").Append(CRLF)
	End If
	Return myBool
End Sub