﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.28
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
	Private clvFlugtyp As CustomListView
	Private lblNr As Label
	Private lblFlugtyp As Label
	Private lblPicDual As Label
	Private lblBemerkung As Label
	Private myXUI As XUI	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	
	Activity.LoadLayout("LayoutFlugtyp")
	Activity.AddMenuItem3("Add", "evAdd", LoadBitmap(File.DirAssets, "plus.png"),True)
End Sub

Sub Activity_Resume
	MyRefreshFlugtyp
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	
End Sub

Sub MyRefreshFlugtyp
	Dim cur As Cursor
	Dim i As Int
	clvFlugtyp.Clear
	cur = Main.SQL1.ExecQuery("SELECT * FROM Flugtyp ORDER BY Nr")
	If cur.RowCount=0 Then
		ToastMessageShow("Keine Flugtypen vorhanden!",False)
	Else
		cur.Position=0
		For i=0 To cur.RowCount-1
			cur.Position=i
			Dim st As Sdata2
			st.Initialize
			st.MyId=cur.GetString("Id")
			st.MyFlugtyp=cur.GetString("Flugtyp")
			st.MyPicDual=cur.GetString("PicDual")
			st.MyBemerkung=cur.GetString("Bemerkung")
			st.MyNr=cur.GetString("Nr")
			st.MyColor=0
			
			Dim pnl As Panel = myXUI.CreatePanel(Null)
			pnl.Color=myXUI.Color_White
			pnl.SetLayoutAnimated(0dip, 0dip, 0dip, clvFlugtyp.AsView.Width, 50dip)
			clvFlugtyp.Add(pnl, st)
		Next
	End If	
End Sub

'POPULATE THE XCUSTOMLISTVIEW WITH THE BUILT ITEMS CREATED IN THE SUB ABOVE
Sub clvFlugtyp_VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	Dim ExtraSize As Int = 25 'Add 25 items at a time, this can be changed to suite your requirements
	For i = Max(0, FirstIndex - ExtraSize) To Min(LastIndex + ExtraSize, clvFlugtyp.Size - 1) 'Loop for adding/removing your items layout to or from the list
		Dim Pnl As Panel = clvFlugtyp.GetPanel(i) 'Declare a new B4XView
		If i > FirstIndex - ExtraSize And i < LastIndex + ExtraSize Then 'Add a new item to the list
			If Pnl.NumberOfViews = 0 Then 'Add items to the list
				Dim t As Sdata2 = clvFlugtyp.GetValue(i) 'Get your custom Type
				Pnl.LoadLayout("LayoutFlugtypCLV") 'Load your Layout
				DateTime.SetTimeZone(0)
				DateTime.DateFormat = "EEE dd.MM.yyyy"
				DateTime.TimeFormat = "HH:mm"
				lblNr.Text=t.MyNr
				lblFlugtyp.Text=t.MyFlugtyp
				lblPicDual.Text=t.MyPicDual
				lblBemerkung.Text=t.MyBemerkung
			End If
		Else 'Remove items from the list
			If Pnl.NumberOfViews > 0 Then
				Pnl.RemoveAllViews 'Remove none visible item from the main xCLV layout
			End If
		End If
	Next
End Sub

Sub evAdd_click
	Main.cADE=1
	StartActivity(AddFlugtyp)
End Sub

Sub clvFlugtyp_ItemClick (Index As Int, Value As Object)
	Dim v As Sdata2
	v=Value
	Main.cFlugtyp.Initialize
	Main.cFlugtyp.MyId=v.MyId
	Main.cFlugtyp.MyFlugtyp=v.MyFlugtyp
	Main.cFlugtyp.MyBemerkung=v.MyBemerkung
	Main.cFlugtyp.MyNr=v.MyNr
	Main.cFlugtyp.MyPicDual=v.MyPicDual
	Main.cFlugtyp.MyColor=v.MyColor
	Main.cADE=2
	StartActivity(AddFlugtyp)

End Sub