﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8.3
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
	Private adpAblaufTauglich As AnotherDatePicker
	Private adpAblaufDeutsch As AnotherDatePicker
	Private adpAblaufEnglisch As AnotherDatePicker
	Private adpAblaufFluglehrer As AnotherDatePicker
	Private adpAblaufKomp As AnotherDatePicker
	Private adpAblaufTrainer As AnotherDatePicker
	Private adpAblaufUebungsleiter As AnotherDatePicker
	Private adpAblaufZuep As AnotherDatePicker
	Private adpGeburtsdatum As AnotherDatePicker
	
	Private edtName As EditText
	Private edtVorname As EditText
	Private edtFluglehrerNr As EditText
	Private edtLand As EditText
	Private edtLevelDeutsch As EditText
	Private edtLevelEnglisch As EditText
	Private edtLizenzNr As EditText
	Private edtOrt As EditText
	Private edtPostleitzahl As EditText
	Private edtStrasse As EditText
	
	Private lblAblaufDeutsch1 As Label
	Private lblAblaufDeutsch2 As Label
	Private lblAblaufEnglisch1 As Label
	Private lblAblaufEnglisch2 As Label
	Private lblAblaufFluglehrer1 As Label
	Private lblAblaufFluglehrer2 As Label
	Private lblAblaufKomp1 As Label
	Private lblAblaufKomp2 As Label
	Private lblAblaufTrainer1 As Label
	Private lblAblaufTrainer2 As Label
	Private lblAblaufUebungsleiter1 As Label
	Private lblAblaufUebungsleiter2 As Label
	Private lblAblaufZuep1 As Label
	Private lblAblaufZuep2 As Label
	Private lblFluglehrerJN As Label
	Private lblFluglehrerNr As Label
	Private lblGeburtsdatum1 As Label
	Private lblGeburtsdatum2 As Label
	Private lblLand As Label
	Private lblLevelDeutsch As Label
	Private lblLevelEnglisch As Label
	Private lblLizenzNr As Label
	Private lblOrt As Label
	Private lblPostleitzahl As Label
	Private lblStrasse As Label
	
	Private lblAblaufTauglich1 As Label
	Private lblAblaufTauglich2 As Label
	Private lblName As Label
	Private lblVorname As Label
	
	Private spiFluglehrerJN As Spinner
	Private pnlPersDaten As Panel
	Private scvPersDaten As ScrollView
	
	Dim mp As PersData
	Private adps As List

End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	'Activity.LoadLayout("Layout1")
	
	Activity.LoadLayout("LayoutPersDaten")
	
	scvPersDaten.Panel.LoadLayout("LayoutPersDatenSCV")
	scvPersDaten.Panel.Height = pnlPersDaten.Height
	adps = Array(adpAblaufDeutsch, adpAblaufEnglisch, adpAblaufTauglich, adpAblaufFluglehrer, _
					adpAblaufKomp, adpAblaufTrainer, adpAblaufUebungsleiter, adpAblaufZuep, adpGeburtsdatum)
	
	Init
	
	Activity.AddMenuItem3("Edit", "evClick", LoadBitmap(File.DirAssets, "Edit.png"),True)
		 
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub Init
	
	Dim cd As ColorDrawable
	cd.Initialize2(Colors.Transparent, 5dip, 1dip, Colors.LightGray)
	Dim cd1 As ColorDrawable
	cd1.Initialize2(Colors.Transparent, 5dip, 1dip, Colors.Transparent)
	
	'Initialisiere Id
	mp.Id=Main.cPersDaten.Id
	
	'Initialisiere Name
	lblName.Background=cd1
	lblName.Text="Name"
	edtName.Background=cd
	edtName.Text=Main.cPersDaten.Name
	mp.Name=Main.cPersDaten.Name
	
	'Initialisiere Vorname
	lblVorname.Background=cd1
	lblVorname.Text="Vorname"
	edtVorname.Background=cd
	edtVorname.Text=Main.cPersDaten.Vorname
	mp.Vorname=Main.cPersDaten.Vorname
	
	'Initialiasiere DatePicker Geburtsdatum
	DateTime.DateFormat="EE dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	lblGeburtsdatum1.Background=cd1
	lblGeburtsdatum1.Text="Geburtsdatum"
	lblGeburtsdatum2.Background=cd
	lblGeburtsdatum2.Text=DateTime.Date(Main.cPersDaten.Geburtsdatum)
	adpGeburtsdatum.SetDate(Main.cPersDaten.Geburtsdatum,False)
	mp.Geburtsdatum=Main.cPersDaten.Geburtsdatum
	
	'Initialisiere Strasse
	lblStrasse.Background=cd1
	lblStrasse.Text="Strasse"
	edtStrasse.Background=cd
	edtStrasse.Text=Main.cPersDaten.Strasse
	mp.Strasse=Main.cPersDaten.Strasse
	
	'Initialisiere Postleitzahl
	lblPostleitzahl.Background=cd1
	lblPostleitzahl.Text="Postleitzahl"
	edtPostleitzahl.Background=cd
	edtPostleitzahl.Text=Main.cPersDaten.Postleitzahl
	mp.Postleitzahl=Main.cPersDaten.Postleitzahl
	
	'Initialisiere Ort
	lblOrt.Background=cd1
	lblPostleitzahl.Text="Ort"
	edtOrt.Background=cd
	edtOrt.Text=Main.cPersDaten.Ort
	mp.Ort=Main.cPersDaten.Ort
	
	'Initialisiere Land
	lblLand.Background=cd1
	lblLand.Text="Land"
	edtLand.Background=cd
	edtLand.Text=Main.cPersDaten.Land
	mp.Land=Main.cPersDaten.Land
	
	'Initialisiere LizenzNr
	lblLizenzNr.Background=cd1
	lblLizenzNr.Text="Lizenz Nr"
	edtLizenzNr.Background=cd
	edtLizenzNr.Text=Main.cPersDaten.LizenzNr
	mp.LizenzNr=Main.cPersDaten.LizenzNr
	
	'Initialisiere Level Deutsch
	lblLevelDeutsch.Background=cd1
	lblLevelDeutsch.Text="Level Deutsch"
	edtLevelDeutsch.Background=cd
	edtLevelDeutsch.Text=Main.cPersDaten.LevelDeutsch
	mp.LevelDeutsch=Main.cPersDaten.LevelDeutsch
	
	'Initialisiere Level Englisch
	lblLevelEnglisch.Background=cd1
	lblLevelEnglisch.Text="Level Englisch"
	edtLevelEnglisch.Background=cd
	edtLevelEnglisch.Text=Main.cPersDaten.LevelEnglisch
	mp.LevelEnglisch=Main.cPersDaten.LevelEnglisch
	
	'Initialiasiere DatePicker Ablauf Deutsch
	DateTime.DateFormat="EE dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	lblAblaufDeutsch1.Background=cd1
	lblAblaufDeutsch1.Text="Ablauf Deutsch"
	lblAblaufDeutsch2.Background=cd
	lblAblaufDeutsch2.Text=DateTime.Date(Main.cPersDaten.AblaufDeutsch)
	adpAblaufDeutsch.SetDate(Main.cPersDaten.AblaufDeutsch,False)
	mp.AblaufDeutsch=Main.cPersDaten.AblaufDeutsch
	
	'Initialiasiere DatePicker Ablauf Englisch
	DateTime.DateFormat="EE dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	lblAblaufEnglisch1.Background=cd1
	lblAblaufEnglisch1.Text="Ablauf Englisch"
	lblAblaufEnglisch2.Background=cd
	lblAblaufEnglisch2.Text=DateTime.Date(Main.cPersDaten.AblaufEnglisch)
	adpAblaufEnglisch.SetDate(Main.cPersDaten.AblaufEnglisch,False)
	mp.AblaufEnglisch=Main.cPersDaten.AblaufEnglisch
	
	'Initialiasiere DatePicker Tauglichkeit
	DateTime.DateFormat="EE dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	lblAblaufTauglich1.Background=cd1
	lblAblaufTauglich1.Text="Ablauf Tauglichkeit"
	lblAblaufTauglich2.Background=cd
	lblAblaufTauglich2.Text=DateTime.Date(Main.cPersDaten.AblaufTauglich)
	adpAblaufTauglich.SetDate(Main.cPersDaten.AblaufTauglich,False)
	mp.AblaufTauglich=Main.cPersDaten.AblaufTauglich
	
	'Initialiasiere DatePicker Zuep
	DateTime.DateFormat="EE dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	lblAblaufZuep1.Background=cd1
	lblAblaufZuep1.Text="Ablauf Zuep"
	lblAblaufZuep2.Background=cd
	lblAblaufZuep2.Text=DateTime.Date(Main.cPersDaten.AblaufZuep)
	adpAblaufZuep.SetDate(Main.cPersDaten.AblaufZuep,False)
	mp.AblaufZuep=Main.cPersDaten.AblaufZuep
	
	'Initialiasiere DatePicker Trainer
	DateTime.DateFormat="EE dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	lblAblaufTrainer1.Background=cd1
	lblAblaufTrainer1.Text="Ablauf Trainer"
	lblAblaufTrainer2.Background=cd
	lblAblaufTrainer2.Text=DateTime.Date(Main.cPersDaten.AblaufTrainer)
	adpAblaufTrainer.SetDate(Main.cPersDaten.AblaufTrainer,False)
	mp.AblaufTrainer=Main.cPersDaten.AblaufTrainer
		
	'Initialiasiere DatePicker Übungsleiter
	DateTime.DateFormat="EE dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	lblAblaufUebungsleiter1.Background=cd1
	lblAblaufUebungsleiter1.Text="Ablauf Übungsleiter"
	lblAblaufUebungsleiter2.Background=cd
	lblAblaufUebungsleiter2.Text=DateTime.Date(Main.cPersDaten.AblaufUebungsleiter)
	adpAblaufUebungsleiter.SetDate(Main.cPersDaten.AblaufUebungsleiter,False)
	mp.AblaufUebungsleiter=Main.cPersDaten.AblaufUebungsleiter
		
	'Initialisiere FluglehrerJN
	lblFluglehrerJN.Background=cd1
	lblFluglehrerJN.Text="Fluglehrer J/N?"
	spiFluglehrerJN.Background=cd
	spiFluglehrerJN.Add("Nein")
	spiFluglehrerJN.Add("Ja")
	spiFluglehrerJN.SelectedIndex=Main.cPersDaten.FluglehrerJN
	mp.FluglehrerJN=Main.cPersDaten.FluglehrerJN
	
	'Initialisiere Fluglehrer Nr
	lblFluglehrerNr.Background=cd1
	lblFluglehrerNr.Text="Meine Fluglehrer Nr"
	edtFluglehrerNr.Background=cd
	edtFluglehrerNr.Text=Main.cPersDaten.FluglehrerNr
	mp.FluglehrerNr=Main.cPersDaten.FluglehrerNr
	
	'Initialiasiere DatePicker Ablauf Fluglehrer
	DateTime.DateFormat="EE dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	lblAblaufFluglehrer1.Background=cd1
	lblAblaufFluglehrer1.Text="Ablauf Fluglehrer"
	lblAblaufFluglehrer2.Background=cd
	lblAblaufFluglehrer2.Text=DateTime.Date(Main.cPersDaten.AblaufFluglehrer)
	adpAblaufFluglehrer.SetDate(Main.cPersDaten.AblaufFluglehrer,False)
	mp.AblaufFluglehrer=Main.cPersDaten.AblaufFluglehrer
	
	'Initialiasiere DatePicker Ablauf Fluglehrer Komp
	DateTime.DateFormat="EE dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	lblAblaufKomp1.Background=cd1
	lblAblaufKomp1.Text="Ablauf Fluglehrer Komp"
	lblAblaufKomp2.Background=cd
	lblAblaufKomp2.Text=DateTime.Date(Main.cPersDaten.AblaufKomp)
	adpAblaufKomp.SetDate(Main.cPersDaten.AblaufKomp,False)
	mp.AblaufKomp=Main.cPersDaten.AblaufKomp

	
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean
	If KeyCode = KeyCodes.KEYCODE_BACK Then
		For Each adp As AnotherDatePicker In adps
			If adp.IsVisible Then
				adp.btnCancel_Click 'emulate a click on Cancel button
				Return True
			End If
		Next
	End If
	Return False
End Sub

Sub adpGeburtsdatum_Closed (Cancelled As Boolean, Date As Long)
	
	DateTime.DateFormat="EE dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	If Not(Cancelled) Then
		Dim year As Int = DateTime.GetYear(Date) 'ignore
		Dim month As Int = DateTime.GetMonth(Date) 'ignore
		Dim day As Int = DateTime.GetDayOfMonth(Date) 'ignore
		'lblGeburtsdatum2.Text=$"Selected date: $Date{Date}"$
		lblGeburtsdatum2.Text=DateTime.Date(Date)
		mp.Geburtsdatum=Date
	End If
	
End Sub

Sub adpAblaufTauglich_Closed (Cancelled As Boolean, Date As Long)
	
	DateTime.DateFormat="EE dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	If Not(Cancelled) Then
		Dim year As Int = DateTime.GetYear(Date) 'ignore
		Dim month As Int = DateTime.GetMonth(Date) 'ignore
		Dim day As Int = DateTime.GetDayOfMonth(Date) 'ignore
		lblAblaufTauglich2.Text=DateTime.Date(Date)
		mp.AblaufTauglich=Date
	End If
	
End Sub

Sub adpAblaufZuep_Closed (Cancelled As Boolean, Date As Long)
	
	DateTime.DateFormat="EE dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	If Not(Cancelled) Then
		Dim year As Int = DateTime.GetYear(Date) 'ignore
		Dim month As Int = DateTime.GetMonth(Date) 'ignore
		Dim day As Int = DateTime.GetDayOfMonth(Date) 'ignore
		lblAblaufZuep2.Text=DateTime.Date(Date)
		mp.AblaufZuep=Date
	End If
	
End Sub

Sub adpAblaufUebungsleiter_Closed (Cancelled As Boolean, Date As Long)
	
	DateTime.DateFormat="EE dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	If Not(Cancelled) Then
		Dim year As Int = DateTime.GetYear(Date) 'ignore
		Dim month As Int = DateTime.GetMonth(Date) 'ignore
		Dim day As Int = DateTime.GetDayOfMonth(Date) 'ignore
		lblAblaufUebungsleiter2.Text=DateTime.Date(Date)
		mp.AblaufUebungsleiter=Date
	End If
	
End Sub

Sub adpAblaufTrainer_Closed (Cancelled As Boolean, Date As Long)
	
	DateTime.DateFormat="EE dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	If Not(Cancelled) Then
		Dim year As Int = DateTime.GetYear(Date) 'ignore
		Dim month As Int = DateTime.GetMonth(Date) 'ignore
		Dim day As Int = DateTime.GetDayOfMonth(Date) 'ignore
		lblAblaufTrainer2.Text=DateTime.Date(Date)
		mp.AblaufTrainer=Date
	End If
	
End Sub

Sub adpAblaufKomp_Closed (Cancelled As Boolean, Date As Long)
	
	DateTime.DateFormat="EE dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	If Not(Cancelled) Then
		Dim year As Int = DateTime.GetYear(Date) 'ignore
		Dim month As Int = DateTime.GetMonth(Date) 'ignore
		Dim day As Int = DateTime.GetDayOfMonth(Date) 'ignore
		lblAblaufKomp2.Text=DateTime.Date(Date)
		mp.AblaufKomp=Date
	End If
	
End Sub

Sub adpAblaufFluglehrer_Closed (Cancelled As Boolean, Date As Long)
	
	DateTime.DateFormat="EE dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	If Not(Cancelled) Then
		Dim year As Int = DateTime.GetYear(Date) 'ignore
		Dim month As Int = DateTime.GetMonth(Date) 'ignore
		Dim day As Int = DateTime.GetDayOfMonth(Date) 'ignore
		lblAblaufFluglehrer2.Text=DateTime.Date(Date)
		mp.AblaufFluglehrer=Date
	End If
	
End Sub

Sub adpAblaufEnglisch_Closed (Cancelled As Boolean, Date As Long)
	
	DateTime.DateFormat="EE dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	If Not(Cancelled) Then
		Dim year As Int = DateTime.GetYear(Date) 'ignore
		Dim month As Int = DateTime.GetMonth(Date) 'ignore
		Dim day As Int = DateTime.GetDayOfMonth(Date) 'ignore
		lblAblaufEnglisch2.Text=DateTime.Date(Date)
		mp.AblaufEnglisch=Date
	End If
	
End Sub

Sub adpAblaufDeutsch_Closed (Cancelled As Boolean, Date As Long)
	
	DateTime.DateFormat="EE dd.MM.yyyy"
	DateTime.SetTimeZone(0)
	If Not(Cancelled) Then
		Dim year As Int = DateTime.GetYear(Date) 'ignore
		Dim month As Int = DateTime.GetMonth(Date) 'ignore
		Dim day As Int = DateTime.GetDayOfMonth(Date) 'ignore
		lblAblaufDeutsch2.Text=DateTime.Date(Date)
		mp.AblaufDeutsch=Date
	End If
	
End Sub

Sub edtName_FocusChanged (HasFocus As Boolean)

	Dim myIME As IME
	myIME.Initialize("evIME")
	myIME.AddHeightChangedEvent
		
	If HasFocus=True Then
		'myIME.SetCustomFilter(edtBemerkung,edtBemerkung.INPUT_TYPE_NUMBERS,"123456789")
		myIME.ShowKeyboard(edtName)
	Else
		myIME.HideKeyboard
	End If

End Sub

Sub lblAblaufTauglich2_Click
	
	adpAblaufTauglich.Show
	
End Sub

Sub lblGeburtsdatum2_Click
	
	adpGeburtsdatum.Show
	
End Sub

Sub lblAblaufZuep2_Click
	
	adpAblaufZuep.Show
	
End Sub

Sub lblAblaufUebungsleiter2_Click
	
	adpAblaufUebungsleiter.Show
	
End Sub

Sub lblAblaufTrainer2_Click
	
	adpAblaufTrainer.Show
	
End Sub

Sub lblAblaufKomp2_Click
	
	adpAblaufKomp.Show
	
End Sub

Sub lblAblaufFluglehrer2_Click
	
	adpAblaufFluglehrer.Show
	
End Sub

Sub lblAblaufEnglisch2_Click
	
	adpAblaufEnglisch.Show
	
End Sub

Sub lblAblaufDeutsch2_Click
	
	adpAblaufDeutsch.Show
	
End Sub

Sub Validate
	
	If Functions.ValStringLen(edtName.text) = True Then
		mp.Name=edtName.text
	Else
		mp.Name=Main.cPersDaten.Name
		edtName.text=Main.cPersDaten.Name
	End If
End Sub

Sub evClick_click
	
	'Validate
	
	Dim w As Map
	w.Initialize
	w.put("Id", mp.id)
	
	Dim m As Map
	m.Initialize
	m.Put("Name", mp.name)
	m.Put("Vorname", mp.Vorname)
	m.Put("Geburtsdatum", mp.Geburtsdatum)
	m.Put("Strasse", mp.Strasse)
	m.Put("Postleitzahl", mp.Postleitzahl)
	m.Put("Ort", mp.Ort)
	m.Put("Land", mp.Land)
	m.Put("LizenzNr", mp.LizenzNr)
	m.Put("LevelDeutsch", mp.LevelDeutsch)
	m.Put("LevelEnglisch", mp.LevelEnglisch)
	m.Put("AblaufDeutsch", mp.AblaufDeutsch)
	m.Put("AblaufEnglisch", mp.AblaufEnglisch)
	m.Put("AblaufTauglich", mp.AblaufTauglich)
	m.Put("AblaufZueP", mp.AblaufZuep)
	m.Put("AblaufTrainer", mp.AblaufTrainer)
	m.Put("AblaufUebungsl", mp.AblaufUebungsleiter)
	m.Put("FluglehrerJN", mp.FluglehrerJN)
	m.Put("FluglehrerNr", mp.FluglehrerNr)
	m.Put("AblaufFluglehrer", mp.AblaufFluglehrer)
	m.Put("AblaufKomp", mp.AblaufKomp)
		
	DBUtils.UpdateRecord2(Main.SQL1, "PersDaten",m,w)
	Activity.Finish
	
	Functions.ReadPersDaten
	
End Sub

Private Sub evIME_HeightChanged (NewHeight As Int, OldHeight As Int)
	scvPersDaten.Height=NewHeight
End Sub

Sub evIME_click
	
End Sub



